package DrumModeling "Library to analyze drum machines"
  package Simplified
    model Section1
      Modelica.Blocks.Interfaces.RealInput Accent annotation(Placement(visible = true, transformation(origin = {-70, 15}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput Output annotation(Placement(visible = true, transformation(origin = {55, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.BooleanInput Trigger annotation(Placement(visible = true, transformation(origin = {-70, -20}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
    equation
      Output = if Trigger then Accent else 0;
      annotation(preferredView = "text", Diagram(coordinateSystem(extent = {{-80, -41.965}, {50, 40}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Line(visible = true, origin = {-24.89, 17.528}, points = {{-38.32, 7.705}, {-3.36, 7.705}, {41.68, -15.41}}), Line(visible = true, origin = {45, 23.948}, points = {{-25, 0}, {25, 0}}), Line(visible = true, origin = {-28.037, -33.975}, points = {{-30.391, -16.025}, {15.195, -16.025}, {15.195, 32.049}}), Text(visible = true, origin = {-0, -74.004}, extent = {{-56.508, -15.996}, {56.508, 15.996}}, textString = "Section 1")}));
    end Section1;

    model Section2
      Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-90, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-55, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-55, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R1(R(displayUnit = "kOhm") = 100000) annotation(Placement(visible = true, transformation(origin = {-28.681, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 1.5e-08, v.start = 0, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {-28.681, 35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R2(R(displayUnit = "kOhm") = 4700) annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {-0, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(visible = true, transformation(origin = {47.312, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {47.312, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Nonlinear.Limiter limiter1(uMin = 0, uMax = 15) annotation(Placement(visible = true, transformation(origin = {80, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(signalVoltage1.n, ground1.p) annotation(Line(visible = true, origin = {-55, -12.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(R1.p, signalVoltage1.p) annotation(Line(visible = true, origin = {-49.56, 13.333}, points = {{10.879, 1.667}, {-5.44, 1.667}, {-5.44, -3.333}}, color = {10, 90, 224}));
      connect(C1.p, signalVoltage1.p) annotation(Line(visible = true, origin = {-49.56, 26.667}, points = {{10.879, 8.333}, {-5.44, 8.333}, {-5.44, -16.667}}, color = {10, 90, 224}));
      connect(R1.n, R2.p) annotation(Line(visible = true, origin = {-6.227, 13.333}, points = {{-12.454, 1.667}, {6.227, 1.667}, {6.227, -3.333}}, color = {10, 90, 224}));
      connect(C1.n, R2.p) annotation(Line(visible = true, origin = {-6.227, 26.667}, points = {{-12.454, 8.333}, {6.227, 8.333}, {6.227, -16.667}}, color = {10, 90, 224}));
      connect(ground2.p, R2.n) annotation(Line(visible = true, origin = {0, -12.5}, points = {{-0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(voltageSensor1.n, ground4.p) annotation(Line(visible = true, origin = {47.312, -12.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(R2.p, voltageSensor1.p) annotation(Line(visible = true, points = {{-23.656, -2.5}, {-23.656, 2.5}, {23.656, 2.5}, {23.656, -2.5}}, color = {10, 90, 224}, origin = {23.656, 12.5}));
      connect(signalVoltage1.v, u) annotation(Line(visible = true, origin = {-76, 0}, points = {{14, 0}, {-14, 0}}, color = {1, 37, 163}));
      connect(voltageSensor1.v, limiter1.u) annotation(Line(visible = true, origin = {62.656, 0}, points = {{-5.344, 0}, {5.344, 0}}, color = {1, 37, 163}));
      connect(limiter1.y, y) annotation(Line(visible = true, origin = {100.5, 0}, points = {{-9.5, 0}, {9.5, 0}}, color = {1, 37, 163}));
      annotation(Diagram(coordinateSystem(extent = {{-97.75, -55}, {120, 52.606}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Line(visible = true, origin = {-12.9, 2.319}, points = {{-35.228, -32.319}, {-35.228, 67.681}, {-31.087, 14.995}, {-23.599, -32.319}, {67.689, -32.319}}, smooth = Smooth.Bezier), Text(visible = true, origin = {-0, -74.004}, extent = {{-56.508, -15.996}, {56.508, 15.996}}, textString = "Section 2")}));
    end Section2;

    model Section346
      Modelica.Blocks.Interfaces.RealInput s6 annotation(Placement(visible = true, transformation(origin = {-112.5, 10}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput s3 annotation(Placement(visible = true, transformation(origin = {-110, 60}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-50, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {52.5, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput s2 annotation(Placement(visible = true, transformation(origin = {-110, -50}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput decay annotation(Placement(visible = true, transformation(origin = {67.5, 35}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {50, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-7.5, -7.015}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 1.5e-08, v.start = 0, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {-22.5, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C2(C(displayUnit = "nF") = 1.5e-08, v.start = 0, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {7.5, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-7.5, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vin1 annotation(Placement(visible = true, transformation(origin = {-37.5, -50}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {-37.5, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout1 annotation(Placement(visible = true, transformation(origin = {22.5, -50}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {22.5, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP1 annotation(Placement(visible = true, transformation(origin = {-7.5, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP2 annotation(Placement(visible = true, transformation(origin = {104.009, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R3(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {54.009, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {89.009, -55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R4(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {102.5, -5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.PR pR1(R(displayUnit = "kOhm") = 500000) annotation(Placement(visible = true, transformation(origin = {90, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R5(R(displayUnit = "kOhm") = 470000) annotation(Placement(visible = true, transformation(origin = {77.5, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vin2 annotation(Placement(visible = true, transformation(origin = {-62.5, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {-62.5, 35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R6(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-32.5, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Basic.VariableResistor resistor annotation(Placement(visible = true, transformation(origin = {-7.5, 35}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Modelica.Blocks.Sources.RealExpression realExpression1(y = RInitial + RFinal * (1 - s6)) annotation(Placement(visible = true, transformation(origin = {-67.5, 10}, extent = {{-20, -10}, {20, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain1(k = 0.55) annotation(Placement(visible = true, transformation(origin = {-62.5, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Real RInitial = 6e3;
      parameter Real RFinal = 46e3;
    equation
      connect(C1.n, C2.p) annotation(Line(visible = true, origin = {-7.5, 55}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(vin1.n, ground3.p) annotation(Line(visible = true, origin = {-37.5, -65}, points = {{0, 5}, {0, -5}}, color = {10, 90, 224}));
      connect(ground4.p, vout1.n) annotation(Line(visible = true, origin = {22.5, -65}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(C1.p, R1.p) annotation(Line(visible = true, points = {{-1.25, 31.008}, {-6.25, 31.008}, {-6.25, -31.008}, {13.75, -31.008}}, color = {10, 90, 224}, origin = {-31.25, 23.992}));
      connect(R1.n, C2.n) annotation(Line(visible = true, points = {{-13.75, -31.008}, {6.25, -31.008}, {6.25, 31.008}, {1.25, 31.008}}, color = {10, 90, 224}, origin = {16.25, 23.992}));
      connect(OP1.pin_n, R1.p) annotation(Line(visible = true, origin = {-27.5, -16.008}, points = {{10, -8.992}, {-10, -8.992}, {-10, 8.993}, {10, 8.993}}, color = {10, 90, 224}));
      connect(OP1.outp, R1.n) annotation(Line(visible = true, origin = {12.5, -18.508}, points = {{-10, -11.492}, {10, -11.492}, {10, 11.493}, {-10, 11.493}}, color = {10, 90, 224}));
      connect(OP1.p, vin1.p) annotation(Line(visible = true, origin = {-30.85, -36.7}, points = {{13.3, 1.65}, {-6.65, 1.65}, {-6.65, -3.3}}, color = {10, 90, 224}));
      connect(vout1.p, OP1.outp) annotation(Line(visible = true, origin = {15.833, -33.333}, points = {{6.667, -6.667}, {6.667, 3.333}, {-13.333, 3.333}}, color = {10, 90, 224}));
      connect(ground2.p, OP2.p) annotation(Line(visible = true, origin = {90.659, -41.7}, points = {{-1.65, -3.3}, {-1.65, 1.65}, {3.3, 1.65}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R3.n) annotation(Line(visible = true, origin = {79.009, -30}, points = {{15, 0}, {-15, 0}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R4.p) annotation(Line(visible = true, origin = {76.509, -17.5}, points = {{17.5, -12.5}, {-2.5, -12.5}, {-2.5, 12.5}, {15.991, 12.5}}, color = {10, 90, 224}));
      connect(OP2.outp, R4.n) annotation(Line(visible = true, origin = {130, -20}, points = {{-15.991, -15}, {2.5, -15}, {2.5, 15}, {-17.5, 15}}, color = {10, 90, 224}));
      connect(pR1.p, OP2.pin_n) annotation(Line(visible = true, origin = {76.946, -7.5}, points = {{3.054, 22.5}, {-2.877, 22.5}, {-2.877, -22.5}, {17.063, -22.5}}, color = {10, 90, 224}));
      connect(R3.p, vout1.p) annotation(Line(visible = true, origin = {29.67, -33.333}, points = {{14.339, 3.333}, {-7.17, 3.333}, {-7.17, -6.667}}, color = {10, 90, 224}));
      connect(R5.n, OP2.outp) annotation(Line(visible = true, points = {{-36.603, 56.292}, {8.397, 56.292}, {8.397, -53.708}, {-10.094, -53.708}}, color = {10, 90, 224}, origin = {124.103, 18.708}));
      connect(decay, pR1.u) annotation(Line(visible = true, origin = {82.5, 32.333}, points = {{-15, 2.667}, {7.5, 2.667}, {7.5, -5.333}}, color = {1, 37, 163}));
      connect(vout1.v, y) annotation(Line(visible = true, origin = {42.5, -50}, points = {{-10, 0}, {10, 0}}, color = {1, 37, 163}));
      connect(ground5.p, vin2.n) annotation(Line(visible = true, origin = {-62.5, 47.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R6.p, vin2.p) annotation(Line(visible = true, origin = {-55.833, 73.333}, points = {{13.333, 1.667}, {-6.667, 1.667}, {-6.667, -3.333}}, color = {10, 90, 224}));
      connect(s3, vin2.v) annotation(Line(visible = true, origin = {-89.75, 60}, points = {{-20.25, 0}, {20.25, 0}}, color = {1, 37, 163}));
      connect(C2.p, R5.p) annotation(Line(visible = true, points = {{-15, -10}, {-20, -10}, {-20, 10}, {55, 10}}, color = {10, 90, 224}, origin = {12.5, 65}));
      connect(C2.p, R6.n) annotation(Line(visible = true, points = {{7.5, -10}, {2.5, -10}, {2.5, 10}, {-12.5, 10}}, color = {10, 90, 224}, origin = {-10, 65}));
      connect(resistor.n, ground1.p) annotation(Line(visible = true, origin = {-7.5, 22.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(resistor.p, C2.p) annotation(Line(visible = true, origin = {-6.691, 51.667}, points = {{-0.809, -6.667}, {-0.809, 3.333}, {4.191, 3.333}}, color = {10, 90, 224}));
      connect(realExpression1.y, resistor.R) annotation(Line(visible = true, origin = {-31.063, 22.5}, points = {{-14.437, -12.5}, {3.563, -12.5}, {3.563, 12.5}, {12.563, 12.5}}, color = {1, 37, 163}));
      connect(gain1.y, vin1.v) annotation(Line(visible = true, origin = {-48, -50}, points = {{-3.5, 0}, {3.5, 0}}, color = {1, 37, 163}));
      connect(s2, gain1.u) annotation(Line(visible = true, origin = {-92.25, -50}, points = {{-17.75, 0}, {17.75, 0}}, color = {1, 37, 163}));
      connect(pR1.n, R4.n) annotation(Line(visible = true, origin = {120.171, 4.099}, points = {{-20.171, 10.901}, {12.671, 10.901}, {12.671, -10.901}, {-7.671, -9.099}}, color = {10, 90, 224}));
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, origin = {2.171, -70}, extent = {{-97.829, -15.996}, {97.829, 15.996}}, textString = "Section 3,4,6"), Line(visible = true, origin = {5.487, 1.059}, points = {{-65.487, 2.217}, {-47.134, 45.735}, {-39.647, -45.046}, {-21.397, 35.441}, {-5.487, -38.494}, {8.083, 16.255}, {19.782, -21.059}, {34.513, 8.941}, {48.794, -2.931}, {67.98, -1.059}}, smooth = Smooth.Bezier)}));
    end Section346;

    model Section5
      Modelica.Blocks.Interfaces.BooleanInput u annotation(Placement(visible = true, transformation(origin = {-154.422, -5.054}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, -0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.BooleanOutput y annotation(Placement(visible = true, transformation(origin = {182.498, -24.427}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      discrete Real ref_time(start = -1);
      Modelica.Blocks.Interfaces.RealOutput r annotation(Placement(visible = true, transformation(origin = {150, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Real width = 5.3e-3;
    equation
      when change(u) then
        ref_time = time;
      end when;
      y = time - ref_time < width;
      r = if y then 1 else 0;
      annotation(preferredView = "text", Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, origin = {0, -70}, extent = {{-93.254, -15.996}, {93.254, 15.996}}, textString = "Section 5"), Line(visible = true, origin = {-12.21, 10}, points = {{-57.79, -30}, {-37.79, -30}, {-37.79, 60}, {22.21, 60}, {22.21, -30}, {88.952, -30}}), Line(visible = true, origin = {-30, 22.695}, points = {{0, 40.945}, {0, -40.945}})}));
    end Section5;

    model Section7
      Modelica.Blocks.Interfaces.BooleanInput s5 annotation(Placement(visible = true, transformation(origin = {-75, -0}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {65, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 3.3e-08) annotation(Placement(visible = true, transformation(origin = {-35, 0}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {0, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(visible = true, transformation(origin = {35, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Boolean not_s5 = not s5;
    equation
      // set C1.v to -11 in the low edge of the signal
      when edge(not_s5) then
        reinit(C1.v, -11);
      end when;
      connect(C1.p, R1.p) annotation(Line(visible = true, origin = {-17.5, 12.5}, points = {{-17.5, -2.5}, {-17.5, 2.5}, {17.5, 2.5}, {17.5, -2.5}}, color = {10, 90, 224}));
      connect(ground2.p, R1.n) annotation(Line(visible = true, origin = {0, -15}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(C1.n, ground2.p) annotation(Line(visible = true, origin = {-17.5, -15}, points = {{-17.5, 5}, {-17.5, 0}, {17.5, 0}, {17.5, -5}}, color = {10, 90, 224}));
      connect(voltageSensor1.p, R1.p) annotation(Line(visible = true, origin = {17.5, 12.5}, points = {{17.5, -2.5}, {17.5, 2.5}, {-17.5, 2.5}, {-17.5, -2.5}}, color = {10, 90, 224}));
      connect(ground2.p, voltageSensor1.n) annotation(Line(visible = true, origin = {17.5, -15}, points = {{-17.5, -5}, {-17.5, 0}, {17.5, 0}, {17.5, 5}}, color = {10, 90, 224}));
      connect(voltageSensor1.v, y) annotation(Line(visible = true, origin = {55, 0}, points = {{-10, 0}, {10, 0}}, color = {1, 37, 163}));
      annotation(Diagram(coordinateSystem(extent = {{-85, -43.278}, {75, 33.205}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, origin = {0, -70}, extent = {{-93.254, -15.996}, {93.254, 15.996}}, textString = "Section 7"), Line(visible = true, origin = {-11.612, 16}, points = {{-38.388, 14}, {-28.388, 14}, {-28.388, -56}, {21.612, 14}, {73.553, 14}})}));
    end Section7;

    model Section8
      Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-75, -1.686}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {80, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput tone annotation(Placement(visible = true, transformation(origin = {-8.455, 10}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {0, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout1 annotation(Placement(visible = true, transformation(origin = {50, -20}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {50, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R13(R(displayUnit = "Ohm") = 200) annotation(Placement(visible = true, transformation(origin = {2.105, 40}, extent = {{-10, -10}, {10, 10}}, rotation = -360)));
      Components.R R14(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {50, 10}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.PR pR2(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {30, 10}, extent = {{-10, -10}, {10, 10}}, rotation = -270)));
      Components.C C6(C(displayUnit = "nF") = 1e-07, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {30, -20}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground18 annotation(Placement(visible = true, transformation(origin = {30, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-40, -1.98}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground19 annotation(Placement(visible = true, transformation(origin = {-40, -43.427}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(pR2.n, R14.p) annotation(Line(visible = true, origin = {40, 22.5}, points = {{-10, -2.5}, {-10, 2.5}, {10, 2.5}, {10, -2.5}}, color = {10, 90, 224}));
      connect(R14.p, R13.n) annotation(Line(visible = true, origin = {37.368, 33.333}, points = {{12.632, -13.333}, {12.632, 6.667}, {-25.263, 6.667}}, color = {10, 90, 224}));
      connect(C6.p, R14.n) annotation(Line(visible = true, origin = {40, -5}, points = {{-10, -5}, {-10, 0}, {10, 0}, {10, 5}}, color = {10, 90, 224}));
      connect(C6.p, pR2.p) annotation(Line(visible = true, origin = {30, -5}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(ground18.p, C6.n) annotation(Line(visible = true, origin = {30, -32.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(ground4.p, vout1.n) annotation(Line(visible = true, origin = {50, -32.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(vout1.p, R14.n) annotation(Line(visible = true, origin = {50, -5}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(vout1.v, y) annotation(Line(visible = true, origin = {65, -20.084}, points = {{-5, 0.084}, {15, 0.084}, {15, 0.084}}, color = {1, 37, 163}));
      connect(tone, pR2.u) annotation(Line(visible = true, origin = {4.772, 10}, points = {{-13.227, 0}, {13.228, 0}}, color = {1, 37, 163}));
      connect(signalVoltage1.n, ground19.p) annotation(Line(visible = true, origin = {-40, -22.704}, points = {{0, 10.724}, {0, -10.723}}, color = {10, 90, 224}));
      connect(signalVoltage1.p, R13.p) annotation(Line(visible = true, origin = {-29.298, 29.34}, points = {{-10.702, -21.32}, {-10.702, 10.66}, {21.403, 10.66}}, color = {10, 90, 224}));
      connect(u, signalVoltage1.v) annotation(Line(visible = true, origin = {-65.667, -1.882}, points = {{-9.333, 0.196}, {-9.333, -0.098}, {18.667, -0.098}}, color = {1, 37, 163}));
      annotation(Diagram(coordinateSystem(extent = {{-77.976, -58.202}, {90, 60}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Line(visible = true, origin = {-20, -3.333}, points = {{-40, 53.333}, {-40, -26.667}, {80, -26.667}}), Line(visible = true, origin = {6.508, 15.585}, points = {{-66.508, 24.415}, {-6.508, 24.415}, {29.524, -3.245}, {43.492, -45.585}}, smooth = Smooth.Bezier), Text(visible = true, origin = {0, -70}, extent = {{-93.254, -15.996}, {93.254, 15.996}}, textString = "Section 8")}));
    end Section8;

    model FullModel
      Section1 section1_1 annotation(Placement(visible = true, transformation(origin = {-45, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section2 section2_1 annotation(Placement(visible = true, transformation(origin = {-10, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section346 section34_1 annotation(Placement(visible = true, transformation(origin = {35, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section5 section5_1 annotation(Placement(visible = true, transformation(origin = {-45, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section7 section7_1 annotation(Placement(visible = true, transformation(origin = {-10, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section8 section8_1 annotation(Placement(visible = true, transformation(origin = {60, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.BooleanPulse Trigger(period = 0.5, width = 1e-3 / 0.5 * 100, startTime = 0.001) annotation(Placement(visible = true, transformation(origin = {-85, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Accent(k = 8) annotation(Placement(visible = true, transformation(origin = {-85, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Decay(k = 0.4) annotation(Placement(visible = true, transformation(origin = {20, 35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Tone(k = 0.1) annotation(Placement(visible = true, transformation(origin = {80, 25}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {91.815, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(section1_1.Output, section2_1.u) annotation(Line(visible = true, origin = {-27.5, -20}, points = {{-7.5, 0}, {7.5, 0}}, color = {1, 37, 163}));
      connect(section2_1.y, section34_1.s2) annotation(Line(visible = true, origin = {8.75, -17.5}, points = {{-8.75, -2.5}, {-3.75, -2.5}, {-3.75, 2.5}, {16.25, 2.5}}, color = {1, 37, 163}));
      connect(section5_1.u, section1_1.Trigger) annotation(Line(visible = true, origin = {-60, -5}, points = {{5, 15}, {-5, 15}, {-5, -20}, {5, -20}}, color = {190, 52, 178}));
      connect(section34_1.y, section8_1.u) annotation(Line(visible = true, origin = {47.5, -10}, points = {{-2.5, 0}, {2.5, -0}}, color = {1, 37, 163}));
      connect(Trigger.y, section1_1.Trigger) annotation(Line(visible = true, origin = {-64.5, -25}, points = {{-9.5, 0}, {9.5, 0}}, color = {255, 0, 255}));
      connect(Accent.y, section1_1.Accent) annotation(Line(visible = true, origin = {-67.25, -2.5}, points = {{-6.75, 12.5}, {-2.75, 12.5}, {-2.75, -12.5}, {12.25, -12.5}}, color = {1, 37, 163}));
      connect(Decay.y, section34_1.decay) annotation(Line(visible = true, origin = {37, 23.333}, points = {{-6, 11.667}, {3, 11.667}, {3, -23.333}}, color = {1, 37, 163}));
      connect(Tone.y, section8_1.tone) annotation(Line(visible = true, origin = {63, 16.667}, points = {{6, 8.333}, {-3, 8.333}, {-3, -16.667}}, color = {1, 37, 163}));
      connect(section34_1.s6, section5_1.r) annotation(Line(visible = true, origin = {-15, -0}, points = {{40, -5}, {-10, -5}, {-10, 5}, {-20, 5}}, color = {1, 37, 163}));
      connect(section5_1.y, section7_1.s5) annotation(Line(visible = true, origin = {-27.5, 15}, points = {{-7.5, -0}, {7.5, 0}}, color = {255, 0, 255}));
      connect(section7_1.y, section34_1.s3) annotation(Line(visible = true, origin = {20, 10}, points = {{-20, 5}, {10, 5}, {10, -10}}, color = {1, 37, 163}));
      connect(section8_1.y, y) annotation(Line(visible = true, origin = {80.907, -10}, points = {{-10.907, 0}, {10.907, 0}}, color = {1, 37, 163}));
      annotation(Documentation(figures = {Figure(title = "Simplified circuit", identifier = "aa548", preferred = true, plots = {Plot(curves = {Curve(y = section2_1.y, legend = "Section 2")}, x = Axis(min = 0.49, max = 0.601, unit = "s"), y = Axis(min = -0.525, max = 8.5)), Plot(curves = {Curve(y = section7_1.y, legend = "Sectiion 7")}, x = Axis(min = 0.49, max = 0.601, unit = "s"), y = Axis(min = -15, max = 1)), Plot(curves = {Curve(y = section8_1.y, legend = "Output")}, x = Axis(min = 0.49, max = 0.601, unit = "s"))}, caption = "Results of the simplified circuit")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullModel;

    model FullModel_Sound
      FullModel fullModel1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/FullModel_Sound.wav"), gain = 0.07) annotation(Placement(visible = true, transformation(origin = {30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(writeMono1.u, fullModel1.y) annotation(Line(visible = true, origin = {14, 0}, points = {{4, 0}, {-4, 0}}, color = {1, 37, 163}));
      annotation(experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes", Tolerance = 1e-7), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullModel_Sound;

    model FullModel_Improved
      Section1 section1_1 annotation(Placement(visible = true, transformation(origin = {-45, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section2 section2_1 annotation(Placement(visible = true, transformation(origin = {-10, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section346 section34_1(RInitial = 5.8e3, RFinal = 52e3, gain1.k = 0.7) annotation(Placement(visible = true, transformation(origin = {35, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section5 section5_1(width = 4e-3) annotation(Placement(visible = true, transformation(origin = {-45, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section7 section7_1 annotation(Placement(visible = true, transformation(origin = {-10, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section8 section8_1 annotation(Placement(visible = true, transformation(origin = {60, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.BooleanPulse Trigger(period = 0.5, width = 1e-3 / 0.5 * 100, startTime = 0.001) annotation(Placement(visible = true, transformation(origin = {-85, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Accent(k = 8) annotation(Placement(visible = true, transformation(origin = {-85, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Decay(k = 0.4) annotation(Placement(visible = true, transformation(origin = {20, 46.662}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Tone(k = 0.1) annotation(Placement(visible = true, transformation(origin = {80, 25}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {127.026, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      SimpleFilter simpleFilter1 annotation(Placement(visible = true, transformation(origin = {-10, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      DCBlocker dCBlocker1(P = 2.5) annotation(Placement(visible = true, transformation(origin = {95, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(section1_1.Output, section2_1.u) annotation(Line(visible = true, origin = {-27.5, -20}, points = {{-7.5, 0}, {7.5, 0}}, color = {1, 37, 163}));
      connect(section2_1.y, section34_1.s2) annotation(Line(visible = true, origin = {8.75, -17.5}, points = {{-8.75, -2.5}, {-3.75, -2.5}, {-3.75, 2.5}, {16.25, 2.5}}, color = {1, 37, 163}));
      connect(section5_1.u, section1_1.Trigger) annotation(Line(visible = true, origin = {-60, -5}, points = {{5, 15}, {-5, 15}, {-5, -20}, {5, -20}}, color = {190, 52, 178}));
      connect(section34_1.y, section8_1.u) annotation(Line(visible = true, origin = {47.5, -10}, points = {{-2.5, 0}, {2.5, -0}}, color = {1, 37, 163}));
      connect(Trigger.y, section1_1.Trigger) annotation(Line(visible = true, origin = {-64.5, -25}, points = {{-9.5, 0}, {9.5, 0}}, color = {255, 0, 255}));
      connect(Accent.y, section1_1.Accent) annotation(Line(visible = true, origin = {-67.25, -2.5}, points = {{-6.75, 12.5}, {-2.75, 12.5}, {-2.75, -12.5}, {12.25, -12.5}}, color = {1, 37, 163}));
      connect(Decay.y, section34_1.decay) annotation(Line(visible = true, origin = {37, 31.108}, points = {{-6, 15.554}, {3, 15.554}, {3, -31.108}}, color = {1, 37, 163}));
      connect(Tone.y, section8_1.tone) annotation(Line(visible = true, origin = {63, 16.667}, points = {{6, 8.333}, {-3, 8.333}, {-3, -16.667}}, color = {1, 37, 163}));
      connect(section5_1.y, section7_1.s5) annotation(Line(visible = true, origin = {-28.75, 22.5}, points = {{-6.25, -7.5}, {-1.25, -7.5}, {-1.25, 7.5}, {8.75, 7.5}}, color = {255, 0, 255}));
      connect(section7_1.y, section34_1.s3) annotation(Line(visible = true, origin = {20, 20}, points = {{-20, 10}, {10, 10}, {10, -20}}, color = {1, 37, 163}));
      connect(section5_1.y, simpleFilter1.u) annotation(Line(visible = true, origin = {-28.75, 10}, points = {{-6.25, 5}, {-1.25, 5}, {-1.25, -5}, {8.75, -5}}, color = {255, 0, 255}));
      connect(simpleFilter1.y, section34_1.s6) annotation(Line(visible = true, origin = {11.25, 0}, points = {{-11.25, 5}, {-1.25, 5}, {-1.25, -5}, {13.75, -5}}, color = {1, 37, 163}));
      connect(dCBlocker1.y, y) annotation(Line(visible = true, origin = {116.013, -10}, points = {{-11.013, 0}, {11.013, -0}}, color = {1, 37, 163}));
      connect(dCBlocker1.u, section8_1.y) annotation(Line(visible = true, origin = {77.5, -10}, points = {{7.5, 0}, {-7.5, 0}}, color = {1, 37, 163}));
      annotation(Documentation(figures = {Figure(title = "Simplified circuit", identifier = "aa548", preferred = true, plots = {Plot(curves = {Curve(y = section2_1.y, legend = "Section 2")}, x = Axis(min = 0.49, max = 0.601, unit = "s"), y = Axis(min = -0.525, max = 8.5)), Plot(curves = {Curve(y = section7_1.y, legend = "Sectiion 7")}, x = Axis(min = 0.49, max = 0.601, unit = "s"), y = Axis(min = -15, max = 1)), Plot(curves = {Curve(y = section8_1.y, legend = "Output")}, x = Axis(min = 0.49, max = 0.601, unit = "s"))}, caption = "Results of the simplified circuit")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullModel_Improved;

    model SimpleFilter
      Modelica.Blocks.Interfaces.BooleanInput u annotation(Placement(visible = true, transformation(origin = {-67.8, -7.2}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {72.2, -7.2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      der(y) = if u then (1 - y) * 20000 else -y * 50;
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25)}));
    end SimpleFilter;

    model FullModel_ImprovedSound
      FullModel_Improved fullModel1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/FullModel_ImprovedSound.wav"), gain = 0.15) annotation(Placement(visible = true, transformation(origin = {30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(writeMono1.u, fullModel1.y) annotation(Line(visible = true, origin = {14, 0}, points = {{4, 0}, {-4, 0}}, color = {1, 37, 163}));
      annotation(experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes", Tolerance = 1e-7), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullModel_ImprovedSound;

    model DCBlocker
      Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-87.985, -12.685}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {81.645, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Tanh tanh1 annotation(Placement(visible = true, transformation(origin = {10, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain1(k = 1 / P) annotation(Placement(visible = true, transformation(origin = {-30, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain2(k = P) annotation(Placement(visible = true, transformation(origin = {42.118, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Real P = 2.5;
    equation
      connect(u, gain1.u) annotation(Line(visible = true, origin = {-72.656, -10.895}, points = {{-15.328, -1.79}, {-15.328, 0.895}, {30.656, 0.895}}, color = {1, 37, 163}));
      connect(gain1.y, tanh1.u) annotation(Line(visible = true, origin = {-12.858, -10}, points = {{-6.142, -0}, {10.858, -0}}, color = {1, 37, 163}));
      connect(tanh1.y, gain2.u) annotation(Line(visible = true, origin = {25.559, -10}, points = {{-4.559, 0}, {4.559, -0}}, color = {1, 37, 163}));
      connect(gain2.y, y) annotation(Line(visible = true, origin = {67.381, -10}, points = {{-14.264, -0}, {14.264, 0}}, color = {1, 37, 163}));
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25)}));
    end DCBlocker;

    model Section346_Modded
      Modelica.Blocks.Interfaces.RealInput s6 annotation(Placement(visible = true, transformation(origin = {-130, 20}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput s3 annotation(Placement(visible = true, transformation(origin = {-110, 60}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-50, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {52.5, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput s2 annotation(Placement(visible = true, transformation(origin = {-110, -50}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput decay annotation(Placement(visible = true, transformation(origin = {67.5, 35}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {50, 100}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-7.5, -7.015}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 1.5e-08, v.start = 0, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {-22.5, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C2(C(displayUnit = "nF") = 1.5e-08, v.start = 0, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {7.5, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-7.5, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vin1 annotation(Placement(visible = true, transformation(origin = {-37.5, -50}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {-37.5, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout1 annotation(Placement(visible = true, transformation(origin = {22.5, -50}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {22.5, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP1 annotation(Placement(visible = true, transformation(origin = {-7.5, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP2 annotation(Placement(visible = true, transformation(origin = {104.009, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R3(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {54.009, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {89.009, -55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R4(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {102.5, -5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.PR pR1(R(displayUnit = "kOhm") = 500000) annotation(Placement(visible = true, transformation(origin = {90, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R5(R(displayUnit = "kOhm") = 470000) annotation(Placement(visible = true, transformation(origin = {77.5, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vin2 annotation(Placement(visible = true, transformation(origin = {-62.5, 60}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {-62.5, 35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R6(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-32.5, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Basic.VariableResistor resistor annotation(Placement(visible = true, transformation(origin = {-7.5, 35}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Modelica.Blocks.Sources.RealExpression realExpression1(y = RInitial + RFinal * (1 - s6) * Pitch) annotation(Placement(visible = true, transformation(origin = {-67.5, 10}, extent = {{-20, -10}, {20, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain1(k = 0.55) annotation(Placement(visible = true, transformation(origin = {-62.5, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Real RInitial = 3e3;
      parameter Real RFinal = 46e3;
      Modelica.Blocks.Interfaces.RealInput Pitch annotation(Placement(visible = true, transformation(origin = {-130, -10}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {0, -100}, extent = {{-20, -20}, {20, 20}}, rotation = -270)));
    equation
      connect(C1.n, C2.p) annotation(Line(visible = true, origin = {-7.5, 55}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(vin1.n, ground3.p) annotation(Line(visible = true, origin = {-37.5, -65}, points = {{0, 5}, {0, -5}}, color = {10, 90, 224}));
      connect(ground4.p, vout1.n) annotation(Line(visible = true, origin = {22.5, -65}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(C1.p, R1.p) annotation(Line(visible = true, points = {{-1.25, 31.008}, {-6.25, 31.008}, {-6.25, -31.008}, {13.75, -31.008}}, color = {10, 90, 224}, origin = {-31.25, 23.992}));
      connect(R1.n, C2.n) annotation(Line(visible = true, points = {{-13.75, -31.008}, {6.25, -31.008}, {6.25, 31.008}, {1.25, 31.008}}, color = {10, 90, 224}, origin = {16.25, 23.992}));
      connect(OP1.pin_n, R1.p) annotation(Line(visible = true, origin = {-27.5, -16.008}, points = {{10, -8.992}, {-10, -8.992}, {-10, 8.993}, {10, 8.993}}, color = {10, 90, 224}));
      connect(OP1.outp, R1.n) annotation(Line(visible = true, origin = {12.5, -18.508}, points = {{-10, -11.492}, {10, -11.492}, {10, 11.493}, {-10, 11.493}}, color = {10, 90, 224}));
      connect(OP1.p, vin1.p) annotation(Line(visible = true, origin = {-30.85, -36.7}, points = {{13.3, 1.65}, {-6.65, 1.65}, {-6.65, -3.3}}, color = {10, 90, 224}));
      connect(vout1.p, OP1.outp) annotation(Line(visible = true, origin = {15.833, -33.333}, points = {{6.667, -6.667}, {6.667, 3.333}, {-13.333, 3.333}}, color = {10, 90, 224}));
      connect(ground2.p, OP2.p) annotation(Line(visible = true, origin = {90.659, -41.7}, points = {{-1.65, -3.3}, {-1.65, 1.65}, {3.3, 1.65}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R3.n) annotation(Line(visible = true, origin = {79.009, -30}, points = {{15, 0}, {-15, 0}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R4.p) annotation(Line(visible = true, origin = {76.509, -17.5}, points = {{17.5, -12.5}, {-2.5, -12.5}, {-2.5, 12.5}, {15.991, 12.5}}, color = {10, 90, 224}));
      connect(OP2.outp, R4.n) annotation(Line(visible = true, origin = {130, -20}, points = {{-15.991, -15}, {2.5, -15}, {2.5, 15}, {-17.5, 15}}, color = {10, 90, 224}));
      connect(pR1.p, OP2.pin_n) annotation(Line(visible = true, origin = {76.946, -7.5}, points = {{3.054, 22.5}, {-2.877, 22.5}, {-2.877, -22.5}, {17.063, -22.5}}, color = {10, 90, 224}));
      connect(R3.p, vout1.p) annotation(Line(visible = true, origin = {29.67, -33.333}, points = {{14.339, 3.333}, {-7.17, 3.333}, {-7.17, -6.667}}, color = {10, 90, 224}));
      connect(R5.n, OP2.outp) annotation(Line(visible = true, points = {{-36.603, 56.292}, {8.397, 56.292}, {8.397, -53.708}, {-10.094, -53.708}}, color = {10, 90, 224}, origin = {124.103, 18.708}));
      connect(decay, pR1.u) annotation(Line(visible = true, origin = {82.5, 32.333}, points = {{-15, 2.667}, {7.5, 2.667}, {7.5, -5.333}}, color = {1, 37, 163}));
      connect(vout1.v, y) annotation(Line(visible = true, origin = {42.5, -50}, points = {{-10, 0}, {10, 0}}, color = {1, 37, 163}));
      connect(ground5.p, vin2.n) annotation(Line(visible = true, origin = {-62.5, 47.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R6.p, vin2.p) annotation(Line(visible = true, origin = {-55.833, 73.333}, points = {{13.333, 1.667}, {-6.667, 1.667}, {-6.667, -3.333}}, color = {10, 90, 224}));
      connect(s3, vin2.v) annotation(Line(visible = true, origin = {-89.75, 60}, points = {{-20.25, 0}, {20.25, 0}}, color = {1, 37, 163}));
      connect(C2.p, R5.p) annotation(Line(visible = true, points = {{-15, -10}, {-20, -10}, {-20, 10}, {55, 10}}, color = {10, 90, 224}, origin = {12.5, 65}));
      connect(C2.p, R6.n) annotation(Line(visible = true, points = {{7.5, -10}, {2.5, -10}, {2.5, 10}, {-12.5, 10}}, color = {10, 90, 224}, origin = {-10, 65}));
      connect(resistor.n, ground1.p) annotation(Line(visible = true, origin = {-7.5, 22.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(resistor.p, C2.p) annotation(Line(visible = true, origin = {-6.691, 51.667}, points = {{-0.809, -6.667}, {-0.809, 3.333}, {4.191, 3.333}}, color = {10, 90, 224}));
      connect(realExpression1.y, resistor.R) annotation(Line(visible = true, origin = {-31.063, 22.5}, points = {{-14.437, -12.5}, {3.563, -12.5}, {3.563, 12.5}, {12.563, 12.5}}, color = {1, 37, 163}));
      connect(gain1.y, vin1.v) annotation(Line(visible = true, origin = {-48, -50}, points = {{-3.5, 0}, {3.5, 0}}, color = {1, 37, 163}));
      connect(s2, gain1.u) annotation(Line(visible = true, origin = {-92.25, -50}, points = {{-17.75, 0}, {17.75, 0}}, color = {1, 37, 163}));
      connect(pR1.n, R4.n) annotation(Line(visible = true, origin = {120.171, 4.099}, points = {{-20.171, 10.901}, {12.671, 10.901}, {12.671, -10.901}, {-7.671, -9.099}}, color = {10, 90, 224}));
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, origin = {-0, -64.004}, extent = {{-97.829, -15.996}, {97.829, 15.996}}, textString = "Section 3,4,6"), Line(visible = true, origin = {5.487, 1.059}, points = {{-65.487, 2.217}, {-47.134, 45.735}, {-39.647, -45.046}, {-21.397, 35.441}, {-5.487, -38.494}, {8.083, 16.255}, {19.782, -21.059}, {34.513, 8.941}, {48.794, -2.931}, {67.98, -1.059}}, smooth = Smooth.Bezier)}));
    end Section346_Modded;

    model FullModel_Modded
      Section1 section1_1 annotation(Placement(visible = true, transformation(origin = {-45, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section2 section2_1 annotation(Placement(visible = true, transformation(origin = {-10, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section346_Modded section34_1(RInitial = 5.8e3, RFinal = 52e3, gain1.k = 0.7) annotation(Placement(visible = true, transformation(origin = {35, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section5 section5_1(width = 4e-3) annotation(Placement(visible = true, transformation(origin = {-45, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section7 section7_1 annotation(Placement(visible = true, transformation(origin = {-10, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section8 section8_1 annotation(Placement(visible = true, transformation(origin = {60, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      SimpleFilter simpleFilter1 annotation(Placement(visible = true, transformation(origin = {-10, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      DCBlocker dCBlocker1(P = 2.5) annotation(Placement(visible = true, transformation(origin = {95, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.PulseGenerator pulseGenerator1(Pulses = 17) annotation(Placement(visible = true, transformation(origin = {-97.376, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.BooleanPulse booleanPulse1(period = 1 / 8) annotation(Placement(visible = true, transformation(origin = {-132.074, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.RandomSource randomSource1(localSeed = 3) annotation(Placement(visible = true, transformation(origin = {10, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/FullModel_Modded.wav"), gain = 0.5) annotation(Placement(visible = true, transformation(origin = {130, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.RandomSource randomSource2(localSeed = 45) annotation(Placement(visible = true, transformation(origin = {-12.274, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.RandomSource randomSource3(localSeed = 35) annotation(Placement(visible = true, transformation(origin = {-11.79, 52.13}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.RandomSource randomSource4(localSeed = 492, Min = 4, Max = 14) annotation(Placement(visible = true, transformation(origin = {-90, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(section1_1.Output, section2_1.u) annotation(Line(visible = true, origin = {-27.5, -20}, points = {{-7.5, 0}, {7.5, 0}}, color = {1, 37, 163}));
      connect(section2_1.y, section34_1.s2) annotation(Line(visible = true, origin = {8.75, -17.5}, points = {{-8.75, -2.5}, {-3.75, -2.5}, {-3.75, 2.5}, {16.25, 2.5}}, color = {1, 37, 163}));
      connect(section5_1.u, section1_1.Trigger) annotation(Line(visible = true, origin = {-60, -5}, points = {{5, 15}, {-5, 15}, {-5, -20}, {5, -20}}, color = {190, 52, 178}));
      connect(section34_1.y, section8_1.u) annotation(Line(visible = true, origin = {47.5, -10}, points = {{-2.5, 0}, {2.5, 0}}, color = {1, 37, 163}));
      connect(section5_1.y, section7_1.s5) annotation(Line(visible = true, origin = {-28.75, 22.5}, points = {{-6.25, -7.5}, {-1.25, -7.5}, {-1.25, 7.5}, {8.75, 7.5}}, color = {255, 0, 255}));
      connect(section7_1.y, section34_1.s3) annotation(Line(visible = true, origin = {20, 20}, points = {{-20, 10}, {10, 10}, {10, -20}}, color = {1, 37, 163}));
      connect(section5_1.y, simpleFilter1.u) annotation(Line(visible = true, origin = {-28.75, 10}, points = {{-6.25, 5}, {-1.25, 5}, {-1.25, -5}, {8.75, -5}}, color = {255, 0, 255}));
      connect(simpleFilter1.y, section34_1.s6) annotation(Line(visible = true, origin = {11.25, 0}, points = {{-11.25, 5}, {-1.25, 5}, {-1.25, -5}, {13.75, -5}}, color = {1, 37, 163}));
      connect(dCBlocker1.u, section8_1.y) annotation(Line(visible = true, origin = {77.5, -10}, points = {{7.5, 0}, {-7.5, 0}}, color = {1, 37, 163}));
      connect(pulseGenerator1.y, section1_1.Trigger) annotation(Line(visible = true, origin = {-71.188, -25}, points = {{-16.188, 0}, {16.188, 0}}, color = {255, 0, 255}));
      connect(booleanPulse1.y, pulseGenerator1.u) annotation(Line(visible = true, origin = {-114.225, -25}, points = {{-6.849, 0}, {6.849, 0}}, color = {255, 0, 255}));
      connect(randomSource1.y, section34_1.Pitch) annotation(Line(visible = true, origin = {30, -53.333}, points = {{-10, -16.667}, {5, -16.667}, {5, 33.333}}, color = {1, 37, 163}));
      connect(randomSource1.u, pulseGenerator1.y) annotation(Line(visible = true, origin = {-52.012, -47.5}, points = {{52.012, -22.5}, {-12.988, -22.5}, {-12.988, 22.5}, {-35.364, 22.5}}, color = {190, 52, 178}));
      connect(writeMono1.u, dCBlocker1.y) annotation(Line(visible = true, origin = {111.866, -33.855}, points = {{6.134, 23.855}, {-1.866, 23.855}, {-6.866, 23.855}}, color = {1, 37, 163}));
      connect(randomSource2.y, section8_1.tone) annotation(Line(visible = true, origin = {39.242, 50}, points = {{-41.516, 25}, {20.758, 25}, {20.758, -50}}, color = {1, 37, 163}));
      connect(randomSource2.u, pulseGenerator1.y) annotation(Line(visible = true, origin = {-57.581, 25}, points = {{35.307, 50}, {-7.419, 50}, {-7.419, -50}, {-29.795, -50}}, color = {190, 52, 178}));
      connect(randomSource3.u, pulseGenerator1.y) annotation(Line(visible = true, origin = {-57.46, 13.565}, points = {{35.67, 38.565}, {-7.54, 38.565}, {-7.54, -38.565}, {-29.917, -38.565}}, color = {190, 52, 178}));
      connect(randomSource3.y, section34_1.decay) annotation(Line(visible = true, origin = {26.07, 34.753}, points = {{-27.86, 17.377}, {13.93, 17.377}, {13.93, -34.753}}, color = {1, 37, 163}));
      connect(randomSource4.y, section1_1.Accent) annotation(Line(visible = true, origin = {-67.888, -2.5}, points = {{-12.112, 12.5}, {-0.388, 12.5}, {-0.388, -12.5}, {12.888, -12.5}}, color = {1, 37, 163}));
      connect(randomSource4.u, pulseGenerator1.y) annotation(Line(visible = true, origin = {-92.896, -7.363}, points = {{-7.104, 17.363}, {-12.104, 17.363}, {-12.104, 0.274}, {12.896, 0.274}, {12.896, -17.637}, {5.52, -17.637}}, color = {190, 52, 178}));
      annotation(experiment(StopTime = 20, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes", __Wolfram_Output_StoreEventPoints = false, __Wolfram_Output_StoreInDoublePrecision = false), Documentation, Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullModel_Modded;
    annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Polygon(visible = true, origin = {0.248, 0.044}, lineColor = {56, 56, 56}, fillColor = {128, 202, 255}, fillPattern = FillPattern.Solid, points = {{99.752, 100}, {99.752, 59.956}, {99.752, -50}, {100, -100}, {49.752, -100}, {-19.752, -100.044}, {-100.248, -100}, {-100.248, -50}, {-90.248, 29.956}, {-90.248, 79.956}, {-40.248, 79.956}, {-20.138, 79.813}, {-0.248, 79.956}, {19.752, 99.956}, {39.752, 99.956}, {59.752, 99.956}}, smooth = Smooth.Bezier), Polygon(visible = true, origin = {0, -13.079}, lineColor = {192, 192, 192}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.HorizontalCylinder, points = {{100, -86.921}, {50, -86.921}, {-50, -86.921}, {-100, -86.921}, {-100, -36.921}, {-100, 53.079}, {-100, 103.079}, {-50, 103.079}, {0, 103.079}, {20, 83.079}, {50, 83.079}, {100, 83.079}, {100, 33.079}, {100, -36.921}}, smooth = Smooth.Bezier), Rectangle(visible = true, origin = {0, -5}, lineColor = {198, 198, 198}, fillColor = {238, 238, 238}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-100, -25}, {100, 25}}), Polygon(visible = true, origin = {-0, -10.704}, lineColor = {113, 113, 113}, fillColor = {255, 255, 255}, points = {{100, -89.296}, {50, -89.296}, {-50, -89.296}, {-100, -89.296}, {-100, -39.296}, {-100, 50.704}, {-100, 100.704}, {-50, 100.704}, {0, 100.704}, {20, 80.704}, {50, 80.704}, {100, 80.704}, {100, 30.704}, {100, -39.296}}, smooth = Smooth.Bezier)}));
  end Simplified;

  package Analysis
    model Section1
      Modelica.Electrical.Analog.Semiconductors.PNP pNP1 annotation(Placement(visible = true, transformation(origin = {30, 35}, extent = {{-10, 10}, {10, -10}}, rotation = 90)));
      Modelica.Electrical.Analog.Semiconductors.NPN nPN1 annotation(Placement(visible = true, transformation(origin = {-3.301, -27.748}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r1(R(displayUnit = "kOhm") = 4700) annotation(Placement(visible = true, transformation(origin = {10, 27.884}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R r2(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {10, -0}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R r3(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {-18.296, -45}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R r4(R(displayUnit = "kOhm") = 22000) annotation(Placement(visible = true, transformation(origin = {-42.198, -27.502}, extent = {{-10, -10}, {10, 10}}, rotation = -180)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {15, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {-18.313, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(visible = true, transformation(origin = {80, 10}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {80, -15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-65, -45}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {-65, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(period = 100e-3, width = 10, amplitude = 5) annotation(Placement(visible = true, transformation(origin = {-92.129, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage2 annotation(Placement(visible = true, transformation(origin = {-30, 30}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {-30, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Ramp ramp1(height = 8, duration = 4) annotation(Placement(visible = true, transformation(origin = {-70, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r5(R(displayUnit = "kOhm") = 100000) annotation(Placement(visible = true, transformation(origin = {55, 10}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
    equation
      connect(r1.p, pNP1.E) annotation(Line(visible = true, origin = {17.5, 45.721}, points = {{-7.5, -7.837}, {-7.5, 4.279}, {7.5, 4.279}, {7.5, -0.721}}, color = {10, 90, 224}));
      connect(r1.n, r2.p) annotation(Line(visible = true, origin = {10, 13.942}, points = {{0, 3.942}, {0, -3.942}}, color = {10, 90, 224}));
      connect(pNP1.B, r1.n) annotation(Line(visible = true, origin = {23.333, 18.333}, points = {{6.667, 6.667}, {6.667, -0.449}, {-13.333, -0.449}}, color = {10, 90, 224}));
      connect(r2.n, nPN1.C) annotation(Line(visible = true, origin = {8.9, -18.499}, points = {{1.1, 8.499}, {1.1, -4.249}, {-2.201, -4.249}}, color = {10, 90, 224}));
      connect(nPN1.B, r3.p) annotation(Line(visible = true, origin = {-16.631, -30.165}, points = {{3.33, 2.417}, {-1.665, 2.417}, {-1.665, -4.835}}, color = {10, 90, 224}));
      connect(r4.p, nPN1.B) annotation(Line(visible = true, origin = {-25, -22.236}, points = {{-7.198, -5.266}, {10, -5.512}, {11.699, -5.512}}, color = {10, 90, 224}));
      connect(ground1.p, nPN1.E) annotation(Line(visible = true, origin = {12.233, -35.165}, points = {{2.767, -4.835}, {2.767, 2.417}, {-5.534, 2.417}}, color = {10, 90, 224}));
      connect(ground2.p, r3.n) annotation(Line(visible = true, origin = {-18.305, -57.5}, points = {{-0.008, -2.5}, {-0.008, 0}, {0.008, 0}, {0.009, 2.5}}, color = {10, 90, 224}));
      connect(pNP1.C, voltageSensor1.p) annotation(Line(visible = true, origin = {57.5, 41.25}, points = {{-22.5, 3.75}, {-22.5, 8.75}, {22.5, 8.75}, {22.5, -21.25}}, color = {10, 90, 224}));
      connect(voltageSensor1.n, ground3.p) annotation(Line(visible = true, origin = {80, -2.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(r4.n, signalVoltage1.p) annotation(Line(visible = true, origin = {-60.733, -30.002}, points = {{8.535, 2.5}, {-4.267, 2.499}, {-4.267, -4.998}}, color = {10, 90, 224}));
      connect(ground4.p, signalVoltage1.n) annotation(Line(visible = true, origin = {-65, -57.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(pulse1.y, signalVoltage1.v) annotation(Line(visible = true, origin = {-76.565, -45}, points = {{-4.564, 0}, {4.565, 0}}, color = {1, 37, 163}));
      connect(ground5.p, signalVoltage2.n) annotation(Line(visible = true, origin = {-30, 17.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(signalVoltage2.p, r1.p) annotation(Line(visible = true, origin = {-10, 44.471}, points = {{-20, -4.471}, {-20, 5.529}, {20, 5.529}, {20, -6.587}}, color = {10, 90, 224}));
      connect(ramp1.y, signalVoltage2.v) annotation(Line(visible = true, origin = {-48, 30}, points = {{-11, 0}, {11, 0}}, color = {1, 37, 163}));
      connect(r5.p, voltageSensor1.p) annotation(Line(visible = true, origin = {67.5, 21.25}, points = {{-12.5, -1.25}, {-12.5, 1.25}, {12.5, 1.25}, {12.5, -1.25}}, color = {10, 90, 224}));
      connect(r5.n, voltageSensor1.n) annotation(Line(visible = true, origin = {67.5, -1.25}, points = {{-12.5, 1.25}, {-12.5, -1.25}, {12.5, -1.25}, {12.5, 1.25}}, color = {10, 90, 224}));
      annotation(Documentation(figures = {Figure(title = "Stage 1", identifier = "f5f8e", preferred = true, plots = {Plot(curves = {Curve(y = signalVoltage1.v, legend = "Trigger")}), Plot(curves = {Curve(y = voltageSensor1.v, legend = "Output Voltage"), Curve(y = signalVoltage2.v, legend = "Accent")})}, caption = "Behavior of the accent circuit.")}), __Wolfram, experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section1;

    model Section2
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-67.638, -10}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-67.577, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r1(R(displayUnit = "kOhm") = 100000) annotation(Placement(visible = true, transformation(origin = {-40, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C c1(C(displayUnit = "nF") = 1.5e-08) annotation(Placement(visible = true, transformation(origin = {-40, 25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r2(R(displayUnit = "kOhm") = 4700) annotation(Placement(visible = true, transformation(origin = {-10, -10}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {-10, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {13.029, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(amplitude = 5, period = 10e-3, width = 3) annotation(Placement(visible = true, transformation(origin = {-125, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(visible = true, transformation(origin = {45, -10}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {45, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.Diode2 diode annotation(Placement(visible = true, transformation(origin = {13.099, -10}, extent = {{-10, -10}, {10, 10}}, rotation = -270)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-95, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(signalVoltage1.n, ground1.p) annotation(Line(visible = true, origin = {-67.607, -22.5}, points = {{-0.03, 2.5}, {-0.03, -0}, {0.03, -0}, {0.03, -2.5}}, color = {10, 90, 224}));
      connect(r1.p, signalVoltage1.p) annotation(Line(visible = true, origin = {-61.758, 3.333}, points = {{11.758, 1.667}, {-5.879, 1.667}, {-5.879, -3.333}}, color = {10, 90, 224}));
      connect(c1.p, signalVoltage1.p) annotation(Line(visible = true, origin = {-61.758, 16.667}, points = {{11.758, 8.333}, {-5.879, 8.333}, {-5.879, -16.667}}, color = {10, 90, 224}));
      connect(r1.n, r2.p) annotation(Line(visible = true, origin = {-16.667, 3.333}, points = {{-13.333, 1.667}, {6.667, 1.667}, {6.667, -3.333}}, color = {10, 90, 224}));
      connect(c1.n, r2.p) annotation(Line(visible = true, origin = {-16.667, 16.667}, points = {{-13.333, 8.333}, {6.667, 8.333}, {6.667, -16.667}}, color = {10, 90, 224}));
      connect(ground2.p, r2.n) annotation(Line(visible = true, origin = {-10, -22.5}, points = {{-0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(voltageSensor1.n, ground4.p) annotation(Line(visible = true, origin = {45, -22.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(r2.p, voltageSensor1.p) annotation(Line(visible = true, points = {{-27.5, -2.5}, {-27.5, 2.5}, {27.5, 2.5}, {27.5, -2.5}}, color = {10, 90, 224}, origin = {17.5, 2.5}));
      connect(diode.p, ground3.p) annotation(Line(visible = true, origin = {13.064, -22.5}, points = {{0.035, 2.5}, {0.035, -0}, {-0.035, -0}, {-0.035, -2.5}}, color = {10, 90, 224}));
      connect(diode.n, r2.p) annotation(Line(visible = true, origin = {2.868, 2.612}, points = {{10.23, -2.613}, {10.23, 2.388}, {-12.868, 2.388}, {-12.868, -2.612}}, color = {10, 90, 224}));
      connect(filter1.y, signalVoltage1.v) annotation(Line(visible = true, origin = {-79.319, -10}, points = {{-4.681, 0}, {4.681, 0}}, color = {1, 37, 163}));
      connect(filter1.u, pulse1.y) annotation(Line(visible = true, origin = {-110.5, -10}, points = {{3.5, 0}, {-3.5, 0}}, color = {1, 37, 163}));
      annotation(__Wolfram(PlotSet(plots = {Plot(name = "Section 2", identifier = "3f709", preferred = true, caption = "Original circuit.", subPlots = {SubPlot(curves = {Curve(x = time, y = voltageSensor1.v, legend = "Output"), Curve(x = time, y = signalVoltage1.v, legend = "Input Pulse")}, range = Range(xmin = 0.009886733657785092, xmax = 0.01082420083330416, xunit = "s", ymin = -3.964237475442044, ymax = 5.083681237721022, yunit = "V"))})})), experiment(StopTime = 0.1, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section2;

    model Section2_NoDiode
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-67.638, -10}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-67.577, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r1(R(displayUnit = "kOhm") = 100000) annotation(Placement(visible = true, transformation(origin = {-40, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C c1(C(displayUnit = "nF") = 1.5e-08) annotation(Placement(visible = true, transformation(origin = {-40, 25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r2(R(displayUnit = "kOhm") = 4700) annotation(Placement(visible = true, transformation(origin = {-10, -10}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {-10, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(amplitude = 5, period = 10e-3, width = 3) annotation(Placement(visible = true, transformation(origin = {-130, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor voltageSensor1 annotation(Placement(visible = true, transformation(origin = {45, -10}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {45, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-95, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(signalVoltage1.n, ground1.p) annotation(Line(visible = true, origin = {-67.607, -22.5}, points = {{-0.03, 2.5}, {-0.03, -0}, {0.03, -0}, {0.03, -2.5}}, color = {10, 90, 224}));
      connect(r1.p, signalVoltage1.p) annotation(Line(visible = true, origin = {-61.758, 3.333}, points = {{11.758, 1.667}, {-5.879, 1.667}, {-5.879, -3.333}}, color = {10, 90, 224}));
      connect(c1.p, signalVoltage1.p) annotation(Line(visible = true, origin = {-61.758, 16.667}, points = {{11.758, 8.333}, {-5.879, 8.333}, {-5.879, -16.667}}, color = {10, 90, 224}));
      connect(r1.n, r2.p) annotation(Line(visible = true, origin = {-16.667, 3.333}, points = {{-13.333, 1.667}, {6.667, 1.667}, {6.667, -3.333}}, color = {10, 90, 224}));
      connect(c1.n, r2.p) annotation(Line(visible = true, origin = {-16.667, 16.667}, points = {{-13.333, 8.333}, {6.667, 8.333}, {6.667, -16.667}}, color = {10, 90, 224}));
      connect(ground2.p, r2.n) annotation(Line(visible = true, origin = {-10, -22.5}, points = {{-0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(voltageSensor1.n, ground4.p) annotation(Line(visible = true, origin = {45, -22.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(r2.p, voltageSensor1.p) annotation(Line(visible = true, points = {{-27.5, -2.5}, {-27.5, 2.5}, {27.5, 2.5}, {27.5, -2.5}}, color = {10, 90, 224}, origin = {17.5, 2.5}));
      connect(pulse1.y, filter1.u) annotation(Line(visible = true, origin = {-113, -10}, points = {{-6, 0}, {6, 0}}, color = {1, 37, 163}));
      connect(filter1.y, signalVoltage1.v) annotation(Line(visible = true, origin = {-79.319, -10}, points = {{-4.681, 0}, {4.681, 0}}, color = {1, 37, 163}));
      annotation(__Wolfram(PlotSet(plots = {Plot(name = "Section 2", identifier = "3f709", preferred = true, caption = "When the diode is removed the negative peak is much higher.", subPlots = {SubPlot(curves = {Curve(x = time, y = voltageSensor1.v, legend = "Output"), Curve(x = time, y = signalVoltage1.v, legend = "Input Pulse")}, range = Range(xmin = 0.009886733657785092, xmax = 0.01082420083330416, xunit = "s", ymin = -5, ymax = 5.083681237721022, yunit = "V"))})})), experiment(StopTime = 0.1, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section2_NoDiode;

    model Section2_Simple
      Modelica.Blocks.Sources.Pulse pulse1(amplitude = 5, period = 10e-3, width = 3) annotation(Placement(visible = true, transformation(origin = {-65, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-30, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Simplified.Section2 section2_1 annotation(Placement(visible = true, transformation(origin = {5, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(pulse1.y, filter1.u) annotation(Line(visible = true, origin = {-48, -10}, points = {{-6, 0}, {6, 0}}, color = {1, 37, 163}));
      connect(filter1.y, section2_1.u) annotation(Line(visible = true, origin = {-12, -10}, points = {{-7, 0}, {7, 0}}, color = {1, 37, 163}));
      annotation(__Wolfram(PlotSet(plots = {Plot(name = "Section 2", identifier = "3f709", preferred = true, caption = "Simplified model using a limiter instead of a diode.", subPlots = {SubPlot(curves = {Curve(x = time, y = section2_1.y, legend = "Output"), Curve(x = time, y = section2_1.u, legend = "Input Pulse")}, range = Range(xmin = 0.009886733657785092, xmax = 0.01082420083330416, xunit = "s", ymin = -2, ymax = 5.083681237721022))})})), experiment(StopTime = 0.1, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section2_Simple;

    model Section3_Simple
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {0, -7.015}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 1.5e-08) annotation(Placement(visible = true, transformation(origin = {-15, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R2(R(displayUnit = "kOhm") = 53800) annotation(Placement(visible = true, transformation(origin = {0, 35}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.C C2(C(displayUnit = "nF") = 1.5e-08) annotation(Placement(visible = true, transformation(origin = {15, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {0, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vin annotation(Placement(visible = true, transformation(origin = {-30, -45}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {-30, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(period = 0.5, width = 0.2, amplitude = 1) annotation(Placement(visible = true, transformation(origin = {-87.685, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout annotation(Placement(visible = true, transformation(origin = {40, -45}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {40, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-57.157, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP1 annotation(Placement(visible = true, transformation(origin = {0, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(ground1.p, R2.n) annotation(Line(visible = true, origin = {0, 22.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R2.p, C2.p) annotation(Line(visible = true, origin = {1.667, 51.667}, points = {{-1.667, -6.667}, {-1.667, 3.333}, {3.333, 3.333}}, color = {10, 90, 224}));
      connect(C1.n, C2.p) annotation(Line(visible = true, origin = {0, 55}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(vin.n, ground3.p) annotation(Line(visible = true, origin = {-30, -57.5}, points = {{-0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(ground4.p, vout.n) annotation(Line(visible = true, origin = {40, -57.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(pulse1.y, filter1.u) annotation(Line(visible = true, origin = {-72.921, -45}, points = {{-3.764, 0}, {3.764, 0}}, color = {1, 37, 163}));
      connect(filter1.y, vin.v) annotation(Line(visible = true, origin = {-41.579, -45}, points = {{-4.579, 0}, {4.579, 0}}, color = {1, 37, 163}));
      connect(C1.p, R1.p) annotation(Line(visible = true, points = {{-1.25, 31.008}, {-6.25, 31.008}, {-6.25, -31.008}, {13.75, -31.008}}, color = {10, 90, 224}, origin = {-23.75, 23.992}));
      connect(R1.n, C2.n) annotation(Line(visible = true, points = {{-13.75, -31.008}, {6.25, -31.008}, {6.25, 31.008}, {1.25, 31.008}}, color = {10, 90, 224}, origin = {23.75, 23.992}));
      connect(OP1.pin_n, R1.p) annotation(Line(visible = true, origin = {-20, -16.008}, points = {{10, -8.992}, {-10, -8.992}, {-10, 8.993}, {10, 8.993}}, color = {10, 90, 224}));
      connect(OP1.outp, R1.n) annotation(Line(visible = true, origin = {20, -18.508}, points = {{-10, -11.492}, {10, -11.492}, {10, 11.493}, {-10, 11.493}}, color = {10, 90, 224}));
      connect(OP1.p, vin.p) annotation(Line(visible = true, origin = {-32.513, -32.525}, points = {{22.463, -2.525}, {1.653, -2.525}, {1.653, -2.5}, {2.513, -2.475}}, color = {10, 90, 224}));
      connect(vout.p, OP1.outp) annotation(Line(visible = true, origin = {30, -31.667}, points = {{10, -3.333}, {10, 1.667}, {-20, 1.667}}, color = {10, 90, 224}));
      annotation(Documentation(figures = {Figure(title = "Section 3", identifier = "b5f1f", preferred = true, plots = {Plot(title = "Section 3", curves = {Curve(y = vout.v)}, x = Axis(min = 0.95, max = 1.1, unit = "s"))}, caption = "Output oscillation when pinging the filter.")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section3_Simple;

    model Section3_Resistors
      Section3_Simple section3_Simple1 annotation(Placement(visible = true, transformation(origin = {0, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Section3_Simple section3_Simple2(R2.R = 6.8e3) annotation(Placement(visible = true, transformation(origin = {0, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      annotation(Documentation(figures = {Figure(title = "Section 3", identifier = "1beea", preferred = true, plots = {Plot(curves = {Curve(y = section3_Simple1.vout.v, legend = "53.8k"), Curve(y = section3_Simple2.vout.v, legend = "6.8k")}, x = Axis(min = 0.95, max = 1.15, unit = "s"), y = Axis(min = -10, max = 10, unit = "V"))}, caption = "Oscillation with resistors of 53.8k and 6.8k")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5}), graphics = {Text(visible = true, origin = {40, -20}, extent = {{-26.419, -3.919}, {26.419, 3.919}}, textString = "This one has R2=6.8k")}), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section3_Resistors;

    model Section3_PingSound
      Section3_Simple section3_Simple1(R2.R = 6.8e3) annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.RealExpression realExpression1(y = section3_Simple1.vout.v) annotation(Placement(visible = true, transformation(origin = {-9.214, 30}, extent = {{-24.214, -10}, {24.214, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(gain = 0.1, filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/Section3_PingSound.wav")) annotation(Placement(visible = true, transformation(origin = {50, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(realExpression1.y, writeMono1.u) annotation(Line(visible = true, origin = {27.711, 30}, points = {{-10.289, -0}, {10.289, 0}}, color = {1, 37, 163}));
      annotation(experiment(StopTime = 4, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section3_PingSound;

    model Section4_Simple
      Components.OpAmp OP1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R1(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {-50, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-15, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R2(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {0, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "uF") = 3.3e-05) annotation(Placement(visible = true, transformation(origin = {15, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.PR pR1(R(displayUnit = "kOhm") = 500000) annotation(Placement(visible = true, transformation(origin = {-15, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant pos(k = 0.1) annotation(Placement(visible = true, transformation(origin = {-50, 71.676}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage svin annotation(Placement(visible = true, transformation(origin = {-80, -10}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {-80, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput vin annotation(Placement(visible = true, transformation(origin = {-115, -10}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor svout annotation(Placement(visible = true, transformation(origin = {45, -15}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Modelica.Blocks.Interfaces.RealOutput vout annotation(Placement(visible = true, transformation(origin = {68.491, -15}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {45, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(ground1.p, OP1.p) annotation(Line(visible = true, origin = {-13.35, -6.7}, points = {{-1.65, -3.3}, {-1.65, 1.65}, {3.3, 1.65}}, color = {10, 90, 224}));
      connect(OP1.pin_n, R1.n) annotation(Line(visible = true, origin = {-25, 5}, points = {{15, 0}, {-15, -0}}, color = {10, 90, 224}));
      connect(OP1.pin_n, R2.p) annotation(Line(visible = true, origin = {-27.5, 17.5}, points = {{17.5, -12.5}, {-2.5, -12.5}, {-2.5, 12.5}, {17.5, 12.5}}, color = {10, 90, 224}));
      connect(OP1.outp, R2.n) annotation(Line(visible = true, origin = {27.5, 15}, points = {{-17.5, -15}, {2.5, -15}, {2.5, 15}, {-17.5, 15}}, color = {10, 90, 224}));
      connect(pR1.n, C1.p) annotation(Line(visible = true, origin = {0, 50}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(pR1.p, OP1.pin_n) annotation(Line(visible = true, origin = {-23.75, 27.5}, points = {{-1.25, 22.5}, {-6.25, 22.5}, {-6.25, -22.5}, {13.75, -22.5}}, color = {10, 90, 224}));
      connect(C1.n, OP1.outp) annotation(Line(visible = true, origin = {23.75, 25}, points = {{1.25, 25}, {6.25, 25}, {6.25, -25}, {-13.75, -25}}, color = {10, 90, 224}));
      connect(pos.y, pR1.u) annotation(Line(visible = true, origin = {-23, 68.451}, points = {{-16, 3.225}, {8, 3.225}, {8, -6.451}}, color = {1, 37, 163}));
      connect(svin.p, R1.p) annotation(Line(visible = true, origin = {-73.333, 3.333}, points = {{-6.667, -3.333}, {-6.667, 1.667}, {13.333, 1.667}}, color = {10, 90, 224}));
      connect(svin.n, ground2.p) annotation(Line(visible = true, origin = {-80, -22.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(svin.v, vin) annotation(Line(visible = true, origin = {-101, -10}, points = {{14, -0}, {-14, 0}}, color = {1, 37, 163}));
      connect(svout.p, OP1.outp) annotation(Line(visible = true, origin = {33.333, -1.667}, points = {{11.667, -3.333}, {11.667, 1.667}, {-23.333, 1.667}}, color = {10, 90, 224}));
      connect(svout.v, vout) annotation(Line(visible = true, origin = {61.745, -15}, points = {{-6.745, -0}, {6.745, 0}}, color = {1, 37, 163}));
      connect(ground3.p, svout.n) annotation(Line(visible = true, origin = {45, -26.15}, points = {{0, -3.85}, {0, 1.15}}, color = {10, 90, 224}));
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section4_Simple;

    model Section3and4
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-45, -7.015}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 1.5e-08) annotation(Placement(visible = true, transformation(origin = {-60, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R2(R(displayUnit = "kOhm") = 6800) annotation(Placement(visible = true, transformation(origin = {-45, 35}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.C C2(C(displayUnit = "nF") = 1.5e-08) annotation(Placement(visible = true, transformation(origin = {-30, 55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-45, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vin1 annotation(Placement(visible = true, transformation(origin = {-75, -45}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {-75, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(period = 0.5, width = 0.2, amplitude = 1) annotation(Placement(visible = true, transformation(origin = {-132.685, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout annotation(Placement(visible = true, transformation(origin = {-5, -45}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {-5, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-102.157, -45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP1 annotation(Placement(visible = true, transformation(origin = {-45, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP2 annotation(Placement(visible = true, transformation(origin = {66.509, -35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R3(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {16.509, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {51.509, -55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R4(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {65, -5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C3(C(displayUnit = "uF") = 3.3e-05) annotation(Placement(visible = true, transformation(origin = {80, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.PR pR1(R(displayUnit = "kOhm") = 500000) annotation(Placement(visible = true, transformation(origin = {51.509, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant pos1(k = 0.9) annotation(Placement(visible = true, transformation(origin = {16.509, 36.676}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor svout1 annotation(Placement(visible = true, transformation(origin = {110, -50}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Modelica.Blocks.Interfaces.RealOutput vout2 annotation(Placement(visible = true, transformation(origin = {135, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {110, -75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R5(R(displayUnit = "kOhm") = 470000) annotation(Placement(visible = true, transformation(origin = {42.92, 72.416}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(ground1.p, R2.n) annotation(Line(visible = true, origin = {-45, 22.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R2.p, C2.p) annotation(Line(visible = true, origin = {-43.333, 51.667}, points = {{-1.667, -6.667}, {-1.667, 3.333}, {3.333, 3.333}}, color = {10, 90, 224}));
      connect(C1.n, C2.p) annotation(Line(visible = true, origin = {-45, 55}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(vin1.n, ground3.p) annotation(Line(visible = true, origin = {-75, -57.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(ground4.p, vout.n) annotation(Line(visible = true, origin = {-5, -57.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(pulse1.y, filter1.u) annotation(Line(visible = true, origin = {-117.921, -45}, points = {{-3.764, 0}, {3.764, 0}}, color = {1, 37, 163}));
      connect(filter1.y, vin1.v) annotation(Line(visible = true, origin = {-86.578, -45}, points = {{-4.579, 0}, {4.578, 0}}, color = {1, 37, 163}));
      connect(C1.p, R1.p) annotation(Line(visible = true, points = {{-1.25, 31.008}, {-6.25, 31.008}, {-6.25, -31.008}, {13.75, -31.008}}, color = {10, 90, 224}, origin = {-68.75, 23.992}));
      connect(R1.n, C2.n) annotation(Line(visible = true, points = {{-13.75, -31.008}, {6.25, -31.008}, {6.25, 31.008}, {1.25, 31.008}}, color = {10, 90, 224}, origin = {-21.25, 23.992}));
      connect(OP1.pin_n, R1.p) annotation(Line(visible = true, origin = {-65, -16.008}, points = {{10, -8.992}, {-10, -8.992}, {-10, 8.993}, {10, 8.993}}, color = {10, 90, 224}));
      connect(OP1.outp, R1.n) annotation(Line(visible = true, origin = {-25, -18.508}, points = {{-10, -11.492}, {10, -11.492}, {10, 11.493}, {-10, 11.493}}, color = {10, 90, 224}));
      connect(OP1.p, vin1.p) annotation(Line(visible = true, origin = {-65.03, -33.02}, points = {{9.98, -2.03}, {4.98, -2.03}, {4.98, 3.02}, {-9.97, 3.02}, {-9.97, -1.98}}, color = {10, 90, 224}));
      connect(vout.p, OP1.outp) annotation(Line(visible = true, origin = {-15, -31.667}, points = {{10, -3.333}, {10, 1.667}, {-20, 1.667}}, color = {10, 90, 224}));
      connect(ground2.p, OP2.p) annotation(Line(visible = true, origin = {53.159, -41.7}, points = {{-1.65, -3.3}, {-1.65, 1.65}, {3.3, 1.65}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R3.n) annotation(Line(visible = true, origin = {41.509, -30}, points = {{15, 0}, {-15, 0}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R4.p) annotation(Line(visible = true, origin = {39.009, -17.5}, points = {{17.5, -12.5}, {-2.5, -12.5}, {-2.5, 12.5}, {15.991, 12.5}}, color = {10, 90, 224}));
      connect(OP2.outp, R4.n) annotation(Line(visible = true, origin = {92.5, -20}, points = {{-15.991, -15}, {2.5, -15}, {2.5, 15}, {-17.5, 15}}, color = {10, 90, 224}));
      connect(pR1.p, OP2.pin_n) annotation(Line(visible = true, origin = {42.759, -7.5}, points = {{-1.25, 22.5}, {-6.25, 22.5}, {-6.25, -22.5}, {13.75, -22.5}}, color = {10, 90, 224}));
      connect(pos1.y, pR1.u) annotation(Line(visible = true, origin = {43.509, 33.451}, points = {{-16, 3.225}, {8, 3.225}, {8, -6.451}}, color = {1, 37, 163}));
      connect(pR1.n, C3.p) annotation(Line(visible = true, origin = {65.755, 15}, points = {{-4.245, -0}, {4.245, 0}}, color = {10, 90, 224}));
      connect(C3.n, OP2.outp) annotation(Line(visible = true, origin = {89.127, -10}, points = {{0.873, 25}, {5.873, 25}, {5.873, -25}, {-12.618, -25}}, color = {10, 90, 224}));
      connect(svout1.p, OP2.outp) annotation(Line(visible = true, origin = {98.836, -36.667}, points = {{11.164, -3.333}, {11.164, 1.667}, {-22.327, 1.667}}, color = {10, 90, 224}));
      connect(svout1.v, vout2) annotation(Line(visible = true, origin = {127.5, -50}, points = {{-7.5, 0}, {7.5, -0}}, color = {1, 37, 163}));
      connect(ground5.p, svout1.n) annotation(Line(visible = true, origin = {110, -62.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R3.p, vout.p) annotation(Line(visible = true, origin = {-1.164, -31.667}, points = {{7.673, 1.667}, {-3.836, 1.667}, {-3.836, -3.333}}, color = {10, 90, 224}));
      connect(R5.p, R2.p) annotation(Line(visible = true, origin = {-19.027, 63.277}, points = {{51.947, 9.139}, {-25.973, 9.139}, {-25.973, -18.277}}, color = {10, 90, 224}));
      connect(R5.n, C3.n) annotation(Line(visible = true, origin = {81.107, 43.708}, points = {{-28.187, 28.708}, {13.893, 28.708}, {13.893, -28.708}, {8.893, -28.708}}, color = {10, 90, 224}));
      annotation(Documentation(figures = {Figure(title = "Section 3 and 4", identifier = "b5f1f", preferred = true, plots = {Plot(title = "Section 3", curves = {Curve(y = vout.v)}, x = Axis(min = 1, max = 2, unit = "s"))}, caption = "Ouput of the filter after adding feedback")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section3and4;

    model Section3and4_Sound
      Section3and4 section3and4_1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/Section3and4_Sound.wav"), gain = 0.09) annotation(Placement(visible = true, transformation(origin = {37.516, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(section3and4_1.vout2, writeMono1.u) annotation(Line(visible = true, origin = {17.758, -0}, points = {{-7.758, 0}, {7.758, -0}}, color = {1, 37, 163}));
      annotation(experiment(StopTime = 4, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section3and4_Sound;

    model Section5
      Components.C C1(C(displayUnit = "nF") = 1e-07, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {40, -25}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {5, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {85, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {40, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {5, 20}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R2(R(displayUnit = "kOhm") = 22000) annotation(Placement(visible = true, transformation(origin = {85, 20}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.VCC vCC1 annotation(Placement(visible = true, transformation(origin = {5, 45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.VCC vCC2 annotation(Placement(visible = true, transformation(origin = {85, 45}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout annotation(Placement(visible = true, transformation(origin = {120, -20}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {120, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R3(R(displayUnit = "kOhm") = 2700) annotation(Placement(visible = true, transformation(origin = {-30, -25}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R4(R(displayUnit = "kOhm") = 8200) annotation(Placement(visible = true, transformation(origin = {-50, -10}, extent = {{-10, -10}, {10, 10}}, rotation = -180)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {-30, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-65, -30}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground6 annotation(Placement(visible = true, transformation(origin = {-65, -55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(period = 0.5, width = 0.5 / 2.5, amplitude = 5) annotation(Placement(visible = true, transformation(origin = {-125, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-94.472, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.NPN T1 annotation(Placement(visible = true, transformation(origin = {-10, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.NPN T2 annotation(Placement(visible = true, transformation(origin = {70, -5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(C1.n, ground3.p) annotation(Line(visible = true, origin = {40, -37.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(vCC1.pin, R1.p) annotation(Line(visible = true, origin = {5, 32.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(vCC2.pin, R2.p) annotation(Line(visible = true, origin = {85, 32.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(ground4.p, vout.n) annotation(Line(visible = true, origin = {120, -35}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(R3.p, R4.p) annotation(Line(visible = true, origin = {-33.333, -11.667}, points = {{3.333, -3.333}, {3.333, 1.667}, {-6.667, 1.667}}, color = {10, 90, 224}));
      connect(R3.n, ground5.p) annotation(Line(visible = true, origin = {-30, -37.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(signalVoltage1.p, R4.n) annotation(Line(visible = true, origin = {-63.333, -13.333}, points = {{-1.667, -6.667}, {-1.667, 3.333}, {3.333, 3.333}}, color = {10, 90, 224}));
      connect(ground6.p, signalVoltage1.n) annotation(Line(visible = true, origin = {-65, -42.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(pulse1.y, filter1.u) annotation(Line(visible = true, origin = {-110.236, -30}, points = {{-3.764, 0}, {3.764, 0}}, color = {1, 37, 163}));
      connect(filter1.y, signalVoltage1.v) annotation(Line(visible = true, origin = {-77.736, -30}, points = {{-5.736, 0}, {5.736, -0}}, color = {1, 37, 163}));
      connect(T1.B, R3.p) annotation(Line(visible = true, origin = {-26.667, -11.667}, points = {{6.667, 1.667}, {-3.333, 1.667}, {-3.333, -3.333}}, color = {10, 90, 224}));
      connect(T1.C, R1.n) annotation(Line(visible = true, origin = {3.333, -0}, points = {{-3.333, -5}, {1.667, -5}, {1.667, 10}}, color = {10, 90, 224}));
      connect(T1.E, ground1.p) annotation(Line(visible = true, origin = {3.333, -23.333}, points = {{-3.333, 8.333}, {1.667, 8.333}, {1.667, -16.667}}, color = {10, 90, 224}));
      connect(T1.C, C1.p) annotation(Line(visible = true, origin = {26.667, -8.333}, points = {{-26.667, 3.333}, {13.333, 3.333}, {13.333, -6.667}}, color = {10, 90, 224}));
      connect(T2.B, C1.p) annotation(Line(visible = true, origin = {46.667, -8.333}, points = {{13.333, 3.333}, {-6.667, 3.333}, {-6.667, -6.667}}, color = {10, 90, 224}));
      connect(R2.n, T2.C) annotation(Line(visible = true, origin = {83.333, 3.333}, points = {{1.667, 6.667}, {1.667, -3.333}, {-3.333, -3.333}}, color = {10, 90, 224}));
      connect(vout.p, T2.C) annotation(Line(visible = true, origin = {106.667, -3.333}, points = {{13.333, -6.667}, {13.333, 3.333}, {-26.667, 3.333}}, color = {10, 90, 224}));
      connect(T2.E, ground2.p) annotation(Line(visible = true, origin = {83.333, -20}, points = {{-3.333, 10}, {1.667, 10}, {1.667, -20}}, color = {10, 90, 224}));
      annotation(Documentation(figures = {Figure(title = "Section 5", identifier = "198ed", preferred = true, plots = {Plot(curves = {Curve(y = vout.v, legend = "Output signal"), Curve(y = signalVoltage1.v, legend = "Trigger signal"), Curve(y = C1.v, legend = "Capacitor voltage")}, x = Axis(min = 0.49, max = 0.52, unit = "s"), y = Axis(min = -0.144717573221758, max = 15.30857740585774, unit = "V"))}, caption = "Pulse produced per every trigger")}), experiment(StopTime = 1, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section5;

    model Section7
      Modelica.Electrical.Analog.Semiconductors.NPN T1 annotation(Placement(visible = true, transformation(origin = {-5, 8.453}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R1(R(displayUnit = "kOhm") = 22000) annotation(Placement(visible = true, transformation(origin = {10, 33.453}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {10, -18.881}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.VCC vCC1 annotation(Placement(visible = true, transformation(origin = {10, 58.453}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.Diode D1 annotation(Placement(visible = true, transformation(origin = {45, 4.311}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {45, -18.881}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R2(R(displayUnit = "kOhm") = 1000) annotation(Placement(visible = true, transformation(origin = {-30, 8.453}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(Placement(visible = true, transformation(origin = {-55, -6.547}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {-55, -31.547}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(period = 0.5, width = 100 * 5.6e-3 / 0.5, amplitude = 15) annotation(Placement(visible = true, transformation(origin = {-107.639, -6.547}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout annotation(Placement(visible = true, transformation(origin = {95, 4.587}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {95, -18.881}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-78.261, -6.609}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {70, -18.881}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R3(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {70, 4.587}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.C C1(C(displayUnit = "nF") = 3.3e-08) annotation(Placement(visible = true, transformation(origin = {30, 21.119}, extent = {{-10, -10}, {10, 10}}, rotation = -360)));
    equation
      connect(R1.n, T1.C) annotation(Line(visible = true, origin = {8.333, 16.787}, points = {{1.667, 6.667}, {1.667, -3.333}, {-3.333, -3.333}}, color = {10, 90, 224}));
      connect(T1.E, ground1.p) annotation(Line(visible = true, origin = {8.333, -0.658}, points = {{-3.333, 4.111}, {1.667, 4.111}, {1.667, -8.223}}, color = {10, 90, 224}));
      connect(vCC1.pin, R1.p) annotation(Line(visible = true, origin = {10, 45.953}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(D1.n, ground2.p) annotation(Line(visible = true, origin = {65.724, -4.881}, points = {{-20.724, -0.808}, {-20.724, -4}, {-20.724, -4}}, color = {10, 90, 224}));
      connect(R2.n, T1.B) annotation(Line(visible = true, origin = {-17.912, 7.846}, points = {{-2.088, 0.607}, {1.044, 0.607}, {2.912, 0.607}}, color = {10, 90, 224}));
      connect(signalVoltage1.p, R2.p) annotation(Line(visible = true, origin = {-50, 6.786}, points = {{-5, -3.333}, {-5, 1.667}, {10, 1.667}}, color = {10, 90, 224}));
      connect(signalVoltage1.n, ground3.p) annotation(Line(visible = true, origin = {-55, -19.047}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(vout.n, ground5.p) annotation(Line(visible = true, origin = {95, -7.147}, points = {{0, 1.734}, {0, -1.734}}, color = {10, 90, 224}));
      connect(filter1.y, signalVoltage1.v) annotation(Line(visible = true, origin = {-63.754, -6.589}, points = {{-3.507, -0.02}, {1.754, -0.021}, {1.754, 0.042}}, color = {1, 37, 163}));
      connect(filter1.u, pulse1.y) annotation(Line(visible = true, origin = {-93.106, -6.578}, points = {{2.845, -0.031}, {0.344, -0.031}, {0.344, 0.031}, {-3.533, 0.031}}, color = {1, 37, 163}));
      connect(R3.p, D1.p) annotation(Line(visible = true, origin = {85, 16.119}, points = {{-15, -1.532}, {-15, 5}, {-40, 5}, {-40, -1.808}}, color = {10, 90, 224}));
      connect(R3.n, ground4.p) annotation(Line(visible = true, origin = {70, -7.147}, points = {{0, 1.734}, {0, -1.734}}, color = {10, 90, 224}));
      connect(vout.p, R3.p) annotation(Line(visible = true, origin = {117.5, 16.119}, points = {{-22.5, -1.532}, {-22.5, 5}, {-47.5, 5}, {-47.5, -1.532}}, color = {10, 90, 224}));
      connect(C1.n, D1.p) annotation(Line(visible = true, origin = {43.333, 18.85}, points = {{-3.333, 2.269}, {1.667, 2.269}, {1.667, -4.539}}, color = {10, 90, 224}));
      connect(T1.C, C1.p) annotation(Line(visible = true, origin = {11.25, 16.121}, points = {{-6.25, -2.668}, {-1.25, -2.668}, {-1.25, 4.998}, {8.75, 4.998}}, color = {10, 90, 224}));
      annotation(experiment(StopTime = 2, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes", Tolerance = 1e-5), Documentation(figures = {Figure(title = "Section 7", identifier = "2d97f", preferred = true, plots = {Plot(curves = {Curve(y = signalVoltage1.v, legend = "Input pulse"), Curve(y = vout.v, legend = "Output voltage")}, x = Axis(min = 0.499, max = 0.515, unit = "s"), y = Axis(min = -16, max = 16, unit = "V"))}, caption = "Negative pulse")}), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section7;

    model FullCircuit
      Components.R R1(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {0, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C1(C(displayUnit = "nF") = 1.5e-08, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {-15, 57.568}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R2(R(displayUnit = "kOhm") = 6800) annotation(Placement(visible = true, transformation(origin = {0, 40}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.C C2(C(displayUnit = "nF") = 1.5e-08, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {15, 57.568}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-0, -10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vout1 annotation(Placement(visible = true, transformation(origin = {40, -155}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground4 annotation(Placement(visible = true, transformation(origin = {40, -180}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP1 annotation(Placement(visible = true, transformation(origin = {0, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.OpAmp OP2 annotation(Placement(visible = true, transformation(origin = {110, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R3(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {61.509, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground2 annotation(Placement(visible = true, transformation(origin = {95, -75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R4(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C3(C(displayUnit = "uF") = 3.3e-05, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {125, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.PR pR1(R(displayUnit = "kOhm") = 500000) annotation(Placement(visible = true, transformation(origin = {95, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Decay1(k = 0.35) annotation(Placement(visible = true, transformation(origin = {66.724, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R5(R(displayUnit = "kOhm") = 470000) annotation(Placement(visible = true, transformation(origin = {90, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.PNP T4 annotation(Placement(visible = true, transformation(origin = {-160, -65}, extent = {{-10, 10}, {10, -10}}, rotation = 90)));
      Modelica.Electrical.Analog.Semiconductors.NPN T5 annotation(Placement(visible = true, transformation(origin = {-193.301, -125}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R16(R(displayUnit = "kOhm") = 4700) annotation(Placement(visible = true, transformation(origin = {-180, -67.597}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R17(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {-180, -95}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R19(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {-210, -140}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R18(R(displayUnit = "kOhm") = 22000) annotation(Placement(visible = true, transformation(origin = {-232.445, -125}, extent = {{-10, -10}, {10, 10}}, rotation = -180)));
      Components.Ground ground3 annotation(Placement(visible = true, transformation(origin = {-180, -165}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground6 annotation(Placement(visible = true, transformation(origin = {-210, -165}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage strig1 annotation(Placement(visible = true, transformation(origin = {-255, -140}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground8 annotation(Placement(visible = true, transformation(origin = {-255, -165.481}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(period = 0.5, width = 1e-3 / 0.5 * 100, amplitude = 5, startTime = 0.001) annotation(Placement(visible = true, transformation(origin = {-310, -140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage saccent1 annotation(Placement(visible = true, transformation(origin = {-220, -70}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground9 annotation(Placement(visible = true, transformation(origin = {-220, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R15(R(displayUnit = "kOhm") = 100000) annotation(Placement(visible = true, transformation(origin = {-120, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C7(C(displayUnit = "nF") = 1.5e-08, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {-120, -55}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R20(R(displayUnit = "kOhm") = 4700) annotation(Placement(visible = true, transformation(origin = {-100, -100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground7 annotation(Placement(visible = true, transformation(origin = {-100, -125}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground10 annotation(Placement(visible = true, transformation(origin = {-75, -125}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.Diode2 D2 annotation(Placement(visible = true, transformation(origin = {-75, -85}, extent = {{-10, -10}, {10, 10}}, rotation = -270)));
      Components.C C4(C(displayUnit = "nF") = 1e-07, v.start = 0, v.fixed = true) annotation(Placement(visible = true, transformation(origin = {-200, 5}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground11 annotation(Placement(visible = true, transformation(origin = {-225, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground12 annotation(Placement(visible = true, transformation(origin = {-160, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground13 annotation(Placement(visible = true, transformation(origin = {-200, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R6(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-225, 45}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R7(R(displayUnit = "kOhm") = 22000) annotation(Placement(visible = true, transformation(origin = {-160, 45}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.VCC VCC1 annotation(Placement(visible = true, transformation(origin = {-225, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.VCC VCC2 annotation(Placement(visible = true, transformation(origin = {-160, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R8(R(displayUnit = "kOhm") = 2700) annotation(Placement(visible = true, transformation(origin = {-260, 0}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R9(R(displayUnit = "kOhm") = 8200) annotation(Placement(visible = true, transformation(origin = {-280, 15}, extent = {{-10, -10}, {10, 10}}, rotation = -180)));
      Components.Ground ground14 annotation(Placement(visible = true, transformation(origin = {-260, -23.418}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.NPN T1 annotation(Placement(visible = true, transformation(origin = {-240, 15}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.NPN T2 annotation(Placement(visible = true, transformation(origin = {-175, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Semiconductors.Diode D1 annotation(Placement(visible = true, transformation(origin = {-80, 60}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground15 annotation(Placement(visible = true, transformation(origin = {-80, 35}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.C C5(C(displayUnit = "nF") = 3.3e-08, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {-125, 75}, extent = {{-10, -10}, {10, 10}}, rotation = -360)));
      Modelica.Electrical.Analog.Semiconductors.NPN T3 annotation(Placement(visible = true, transformation(origin = {-85, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R10(R(displayUnit = "kOhm") = 100000) annotation(Placement(visible = true, transformation(origin = {-115, 5}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground16 annotation(Placement(visible = true, transformation(origin = {-70, -22.432}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R11(R(displayUnit = "kOhm") = 47000) annotation(Placement(visible = true, transformation(origin = {0, 15}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R12(R(displayUnit = "MOhm") = 1000000) annotation(Placement(visible = true, transformation(origin = {-45, 75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor trig1 annotation(Placement(visible = true, transformation(origin = {-50, -77.432}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground5 annotation(Placement(visible = true, transformation(origin = {-50, -102.432}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor hold1 annotation(Placement(visible = true, transformation(origin = {-140, -15}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground17 annotation(Placement(visible = true, transformation(origin = {-140, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-280, -140}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R13(R(displayUnit = "Ohm") = 200) annotation(Placement(visible = true, transformation(origin = {15, -70}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.R R14(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {15, -125}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.PR pR2(R(displayUnit = "kOhm") = 10000) annotation(Placement(visible = true, transformation(origin = {-5, -125}, extent = {{-10, -10}, {10, 10}}, rotation = -270)));
      Components.C C6(C(displayUnit = "nF") = 1e-07, v.fixed = true, v.start = 0) annotation(Placement(visible = true, transformation(origin = {15, -155}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground18 annotation(Placement(visible = true, transformation(origin = {15, -180}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Constant Tone1(k = 0.1) annotation(Placement(visible = true, transformation(origin = {-35, -125}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput out annotation(Placement(visible = true, transformation(origin = {71.959, -155}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R R21(R(displayUnit = "kOhm") = 22000) annotation(Placement(visible = true, transformation(origin = {95, -50}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor sec7 annotation(Placement(visible = true, transformation(origin = {-115, 55}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Components.Ground ground19 annotation(Placement(visible = true, transformation(origin = {-115, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.Ground ground20 annotation(Placement(visible = true, transformation(origin = {-147.678, -136.64}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Components.R r1(R = 1000000) annotation(Placement(visible = true, transformation(origin = {-148.431, -103.054}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Modelica.Blocks.Sources.Ramp ramp1(height = 8, duration = 0.001) annotation(Placement(visible = true, transformation(origin = {-267.312, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(R2.p, C2.p) annotation(Line(visible = true, origin = {1.667, 55.046}, points = {{-1.667, -5.046}, {-1.667, 2.523}, {3.333, 2.523}}, color = {10, 90, 224}));
      connect(C1.n, C2.p) annotation(Line(visible = true, origin = {0, 57.568}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(C1.p, R1.p) annotation(Line(visible = true, points = {{-1.25, 41.284}, {-6.25, 41.284}, {-6.25, -41.284}, {13.75, -41.284}}, color = {10, 90, 224}, origin = {-23.75, 16.284}));
      connect(R1.n, C2.n) annotation(Line(visible = true, points = {{-13.75, -41.284}, {6.25, -41.284}, {6.25, 41.284}, {1.25, 41.284}}, color = {10, 90, 224}, origin = {23.75, 16.284}));
      connect(OP1.pin_n, R1.p) annotation(Line(visible = true, origin = {-20, -13.44}, points = {{10, -31.56}, {-10, -31.56}, {-10, -11.56}, {10, -11.56}}, color = {10, 90, 224}));
      connect(OP1.outp, R1.n) annotation(Line(visible = true, origin = {20, -15.94}, points = {{-10, -34.06}, {10, -34.06}, {10, -9.06}, {-10, -9.06}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R3.n) annotation(Line(visible = true, origin = {85.755, -25}, points = {{14.245, 0}, {-14.245, -0}}, color = {10, 90, 224}));
      connect(OP2.pin_n, R4.p) annotation(Line(visible = true, origin = {84.009, -14.932}, points = {{15.991, -10.068}, {-4.009, -10.068}, {-4.009, 14.932}, {15.991, 14.932}}, color = {10, 90, 224}));
      connect(OP2.outp, R4.n) annotation(Line(visible = true, origin = {137.5, -17.432}, points = {{-17.5, -12.568}, {2.5, -12.568}, {2.5, 17.432}, {-17.5, 17.432}}, color = {10, 90, 224}));
      connect(pR1.p, OP2.pin_n) annotation(Line(visible = true, origin = {86.25, -2.5}, points = {{-1.25, 22.5}, {-6.25, 22.5}, {-6.25, -22.5}, {13.75, -22.5}}, color = {10, 90, 224}));
      connect(pR1.n, C3.p) annotation(Line(visible = true, origin = {110, 20}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(C3.n, OP2.outp) annotation(Line(visible = true, origin = {133.75, -5}, points = {{1.25, 25}, {6.25, 25}, {6.25, -25}, {-13.75, -25}}, color = {10, 90, 224}));
      connect(R5.p, R2.p) annotation(Line(visible = true, origin = {26.667, 66.667}, points = {{53.333, 8.333}, {-26.667, 8.333}, {-26.667, -16.667}}, color = {10, 90, 224}));
      connect(R5.n, C3.n) annotation(Line(visible = true, origin = {128.75, 47.5}, points = {{-28.75, 27.5}, {11.25, 27.5}, {11.25, -27.5}, {6.25, -27.5}}, color = {10, 90, 224}));
      connect(ground7.p, R20.n) annotation(Line(visible = true, origin = {-100, -112.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(C4.n, ground13.p) annotation(Line(visible = true, origin = {-200, -7.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(R8.p, R9.p) annotation(Line(visible = true, origin = {-263.333, 13.333}, points = {{3.333, -3.333}, {3.333, 1.667}, {-6.667, 1.667}}, color = {10, 90, 224}));
      connect(R8.n, ground14.p) annotation(Line(visible = true, origin = {-260, -11.709}, points = {{0, 1.709}, {0, -1.709}}, color = {10, 90, 224}));
      connect(T1.B, R8.p) annotation(Line(visible = true, origin = {-256.667, 13.333}, points = {{6.667, 1.667}, {-3.333, 1.667}, {-3.333, -3.333}}, color = {10, 90, 224}));
      connect(T1.C, R6.n) annotation(Line(visible = true, origin = {-226.667, 25}, points = {{-3.333, -5}, {1.667, -5}, {1.667, 10}}, color = {10, 90, 224}));
      connect(T1.E, ground11.p) annotation(Line(visible = true, origin = {-226.667, 3.333}, points = {{-3.333, 6.667}, {1.667, 6.667}, {1.667, -13.333}}, color = {10, 90, 224}));
      connect(T1.C, C4.p) annotation(Line(visible = true, origin = {-210, 18.333}, points = {{-20, 1.667}, {10, 1.667}, {10, -3.333}}, color = {10, 90, 224}));
      connect(T2.B, C4.p) annotation(Line(visible = true, origin = {-195, 18.333}, points = {{10, 1.667}, {-5, 1.667}, {-5, -3.333}}, color = {10, 90, 224}));
      connect(R7.n, T2.C) annotation(Line(visible = true, origin = {-161.667, 28.333}, points = {{1.667, 6.667}, {1.667, -3.333}, {-3.333, -3.333}}, color = {10, 90, 224}));
      connect(T2.E, ground12.p) annotation(Line(visible = true, origin = {-161.667, 6.667}, points = {{-3.333, 8.333}, {1.667, 8.333}, {1.667, -16.667}}, color = {10, 90, 224}));
      connect(D1.n, ground15.p) annotation(Line(visible = true, origin = {-80, 47.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(C5.n, D1.p) annotation(Line(visible = true, origin = {-91.667, 73.333}, points = {{-23.333, 1.667}, {11.667, 1.667}, {11.667, -3.333}}, color = {10, 90, 224}));
      connect(C5.p, T2.C) annotation(Line(visible = true, origin = {-145, 50}, points = {{10, 25}, {5, 25}, {5, -25}, {-20, -25}}, color = {10, 90, 224}));
      connect(R10.n, T3.B) annotation(Line(visible = true, origin = {-100, 5}, points = {{-5, 0}, {5, 0}}, color = {10, 90, 224}));
      connect(R10.p, T2.C) annotation(Line(visible = true, origin = {-143.327, 15.068}, points = {{18.327, -10.068}, {3.327, -10.068}, {3.327, 9.932}, {-21.673, 9.932}}, color = {10, 90, 224}));
      connect(T3.E, ground16.p) annotation(Line(visible = true, origin = {-71.667, -4.144}, points = {{-3.333, 4.144}, {1.667, 4.144}, {1.667, -8.288}}, color = {10, 90, 224}));
      connect(R2.n, R11.p) annotation(Line(visible = true, origin = {0, 27.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(R11.n, ground1.p) annotation(Line(visible = true, origin = {-0, 2.5}, points = {{0, 2.5}, {-0, -2.5}}, color = {10, 90, 224}));
      connect(R11.p, T3.C) annotation(Line(visible = true, origin = {-43, 17.398}, points = {{43, 7.602}, {43, 9.938}, {-27, 9.938}, {-27, -7.398}, {-32, -7.398}}, color = {10, 90, 224}));
      connect(R12.n, R2.p) annotation(Line(visible = true, origin = {-11.667, 66.667}, points = {{-23.333, 8.333}, {11.667, 8.333}, {11.667, -16.667}}, color = {10, 90, 224}));
      connect(R12.p, D1.p) annotation(Line(visible = true, origin = {-71.667, 73.333}, points = {{16.667, 1.667}, {-8.333, 1.667}, {-8.333, -3.333}}, color = {10, 90, 224}));
      connect(trig1.n, ground5.p) annotation(Line(visible = true, origin = {-50, -89.932}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(trig1.p, OP1.p) annotation(Line(visible = true, origin = {-36.683, -59.177}, points = {{-13.317, -8.254}, {-13.317, 4.127}, {26.633, 4.127}}, color = {10, 90, 224}));
      connect(ground17.p, hold1.n) annotation(Line(visible = true, origin = {-140, -27.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(hold1.p, R10.p) annotation(Line(visible = true, origin = {-135, 1.667}, points = {{-5, -6.667}, {-5, 3.333}, {10, 3.333}}, color = {10, 90, 224}));
      connect(pulse1.y, filter1.u) annotation(Line(visible = true, origin = {-295.5, -140}, points = {{-3.5, 0}, {3.5, 0}}, color = {1, 37, 163}));
      connect(R13.p, OP1.outp) annotation(Line(visible = true, origin = {13.333, -53.333}, points = {{1.667, -6.667}, {1.667, 3.333}, {-3.333, 3.333}}, color = {10, 90, 224}));
      connect(pR2.n, R14.p) annotation(Line(visible = true, origin = {5, -112.5}, points = {{-10, -2.5}, {-10, 2.5}, {10, 2.5}, {10, -2.5}}, color = {10, 90, 224}));
      connect(R14.p, R13.n) annotation(Line(visible = true, origin = {15, -97.5}, points = {{0, -17.5}, {0, 17.5}}, color = {10, 90, 224}));
      connect(C6.p, R14.n) annotation(Line(visible = true, origin = {15, -140}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(C6.p, pR2.p) annotation(Line(visible = true, origin = {5, -140}, points = {{10, -5}, {10, 0}, {-10, 0}, {-10, 5}}, color = {10, 90, 224}));
      connect(ground18.p, C6.n) annotation(Line(visible = true, origin = {15, -167.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R15.n, R20.p) annotation(Line(visible = true, origin = {-103.333, -83.333}, points = {{-6.667, 3.333}, {3.333, 3.333}, {3.333, -6.667}}, color = {10, 90, 224}));
      connect(R16.n, R17.p) annotation(Line(visible = true, origin = {-180, -81.299}, points = {{0, 3.701}, {-0, -3.701}}, color = {10, 90, 224}));
      connect(ground6.p, R19.n) annotation(Line(visible = true, origin = {-210, -152.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R18.n, strig1.p) annotation(Line(visible = true, origin = {-250.815, -126.667}, points = {{8.37, 1.667}, {-4.185, 1.667}, {-4.185, -3.333}}, color = {10, 90, 224}));
      connect(ground8.p, strig1.n) annotation(Line(visible = true, origin = {-255, -152.741}, points = {{0, -2.741}, {-0, 2.741}}, color = {10, 90, 224}));
      connect(filter1.y, strig1.v) annotation(Line(visible = true, origin = {-265.5, -140}, points = {{-3.5, 0}, {3.5, 0}}, color = {1, 37, 163}));
      connect(ground9.p, saccent1.n) annotation(Line(visible = true, origin = {-220, -85}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(saccent1.p, R16.p) annotation(Line(visible = true, origin = {-200, -55.698}, points = {{-20, -4.302}, {-20, 3.101}, {20, 3.101}, {20, -1.899}}, color = {10, 90, 224}));
      connect(VCC1.pin, R6.p) annotation(Line(visible = true, origin = {-225, 57.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(VCC2.pin, R7.p) annotation(Line(visible = true, origin = {-160, 57.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(ground4.p, vout1.n) annotation(Line(visible = true, origin = {40, -167.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(R3.p, OP1.outp) annotation(Line(visible = true, origin = {35.377, -37.5}, points = {{16.132, 12.5}, {4.623, 12.5}, {4.623, -12.5}, {-25.377, -12.5}}, color = {10, 90, 224}));
      connect(vout1.p, R14.n) annotation(Line(visible = true, origin = {27.5, -140}, points = {{12.5, -5}, {12.5, 0}, {-12.5, 0}, {-12.5, 5}}, color = {10, 90, 224}));
      connect(R16.p, T4.E) annotation(Line(visible = true, origin = {-172.5, -53.149}, points = {{-7.5, -4.448}, {-7.5, 3.149}, {7.5, 3.149}, {7.5, -1.851}}, color = {10, 90, 224}));
      connect(T4.B, R16.n) annotation(Line(visible = true, origin = {-166.667, -77.148}, points = {{6.667, 2.148}, {6.667, -0.449}, {-13.333, -0.449}}, color = {10, 90, 224}));
      connect(T4.C, R9.n) annotation(Line(visible = true, origin = {-238, -18.042}, points = {{83, -36.958}, {83, -19.39}, {-57, -19.39}, {-57, 33.042}, {-52, 33.042}}, color = {10, 90, 224}));
      connect(R15.p, T4.C) annotation(Line(visible = true, origin = {-142.5, -91.456}, points = {{12.5, 11.456}, {2.5, 11.456}, {2.5, 36.456}, {-12.5, 36.456}}, color = {10, 90, 224}));
      connect(R17.n, T5.C) annotation(Line(visible = true, origin = {-181.1, -115}, points = {{1.1, 10}, {1.1, -5}, {-2.201, -5}}, color = {10, 90, 224}));
      connect(T5.B, R19.p) annotation(Line(visible = true, origin = {-207.767, -126.667}, points = {{4.466, 1.667}, {-2.233, 1.667}, {-2.233, -3.333}}, color = {10, 90, 224}));
      connect(R18.p, T5.B) annotation(Line(visible = true, origin = {-215, -117.717}, points = {{-7.445, -7.283}, {10, -7.283}, {11.699, -7.283}}, color = {10, 90, 224}));
      connect(ground3.p, T5.E) annotation(Line(visible = true, origin = {-181.1, -138.333}, points = {{1.1, -16.667}, {1.1, 8.333}, {-2.201, 8.333}}, color = {10, 90, 224}));
      connect(D2.p, ground10.p) annotation(Line(visible = true, origin = {-75, -105}, points = {{0, 10}, {0, -10}}, color = {10, 90, 224}));
      connect(D2.n, R20.p) annotation(Line(visible = true, origin = {-85, -57.5}, points = {{10, -17.5}, {10, 2.5}, {-15, 2.5}, {-15, -32.5}}, color = {10, 90, 224}));
      connect(OP1.p, D2.n) annotation(Line(visible = true, origin = {-53.35, -61.7}, points = {{43.3, 6.65}, {-21.65, 6.65}, {-21.65, -13.3}}, color = {10, 90, 224}));
      connect(C7.n, R20.p) annotation(Line(visible = true, origin = {-103.333, -66.667}, points = {{-6.667, 11.667}, {3.333, 11.667}, {3.333, -23.333}}, color = {10, 90, 224}));
      connect(C7.p, R15.p) annotation(Line(visible = true, origin = {-138.75, -67.5}, points = {{8.75, 12.5}, {-1.25, 12.5}, {-1.25, -12.5}, {8.75, -12.5}}, color = {10, 90, 224}));
      connect(Decay1.y, pR1.u) annotation(Line(visible = true, origin = {89.241, 37.333}, points = {{-11.517, 2.667}, {5.759, 2.667}, {5.759, -5.333}}, color = {1, 37, 163}));
      connect(Tone1.y, pR2.u) annotation(Line(visible = true, origin = {-20.5, -125}, points = {{-3.5, 0}, {3.5, 0}}, color = {1, 37, 163}));
      connect(vout1.v, out) annotation(Line(visible = true, origin = {60.979, -155}, points = {{-10.979, 0}, {10.979, 0}}, color = {1, 37, 163}));
      connect(OP2.p, R21.p) annotation(Line(visible = true, origin = {96.65, -36.7}, points = {{3.3, 1.65}, {-1.65, 1.65}, {-1.65, -3.3}}, color = {10, 90, 224}));
      connect(R21.n, ground2.p) annotation(Line(visible = true, origin = {95, -62.5}, points = {{0, 2.5}, {0, -2.5}}, color = {10, 90, 224}));
      connect(sec7.p, C5.n) annotation(Line(visible = true, origin = {-115, 70}, points = {{0, -5}, {0, 5}}, color = {10, 90, 224}));
      connect(ground19.p, sec7.n) annotation(Line(visible = true, origin = {-115, 42.5}, points = {{0, -2.5}, {0, 2.5}}, color = {10, 90, 224}));
      connect(r1.n, ground20.p) annotation(Line(visible = true, origin = {-148.054, -118.951}, points = {{-0.377, 5.896}, {-0.377, 0.896}, {0.377, 0.896}, {0.377, -7.689}}, color = {10, 90, 224}));
      connect(r1.p, T4.C) annotation(Line(visible = true, origin = {-150.621, -69.105}, points = {{2.19, -23.949}, {2.19, 11.974}, {-4.379, 14.105}}, color = {10, 90, 224}));
      connect(ramp1.y, saccent1.v) annotation(Line(visible = true, origin = {-241.656, -70}, points = {{-14.656, 0}, {14.656, 0}}, color = {1, 37, 163}));
      annotation(Documentation(figures = {Figure(title = "Full circuit", identifier = "e40f0", preferred = true, plots = {Plot(curves = {Curve(y = trig1.v, legend = "Section 2")}, x = Axis(min = 0.49, max = 0.601, unit = "s"), y = Axis(min = -0.7863058164513461, max = 7.95240122579, unit = "V")), Plot(curves = {Curve(y = sec7.v, legend = "Section 7"), Curve(y = hold1.v, legend = "Section 5")}, x = Axis(min = 0.49, max = 0.601, unit = "s"), y = Axis(min = -15.9, max = 15.3, unit = "V")), Plot(curves = {Curve(y = out, legend = "Output")}, x = Axis(min = 0.49, max = 0.601, unit = "s"))}, caption = "Output of the different sections")}), experiment(StartTime = 0, StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-335, -195}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullCircuit;

    model FullCircuit_Sound
      FullCircuit fullCircuit1 annotation(Placement(visible = true, transformation(origin = {-10, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/FullCircuit_Sound.wav"), gain = 0.07) annotation(Placement(visible = true, transformation(origin = {30, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(writeMono1.u, fullCircuit1.out) annotation(Line(visible = true, origin = {7.321, 10}, points = {{10.679, 0}, {-7.321, -0}}, color = {1, 37, 163}));
      annotation(experiment(StartTime = 0, StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes", Tolerance = 1e-7), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullCircuit_Sound;

    model FullCircuit_Tweaked
      FullCircuit fullCircuit1(R2.R = 6000, R11.R = 45000, Tone1.k = 0.05, Decay1.k = 0.36) annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      WaveIO.WriteMono writeMono1(filename = Modelica.Utilities.Files.loadResource("modelica://DrumModeling/Sounds/FullCircuit_Tweaked.wav"), gain = 0.07) annotation(Placement(visible = true, transformation(origin = {30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(writeMono1.u, fullCircuit1.out) annotation(Line(visible = true, origin = {14, 0}, points = {{4, 0}, {-4, 0}}, color = {1, 37, 163}));
      annotation(experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end FullCircuit_Tweaked;
    annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Polygon(visible = true, origin = {0.248, 0.044}, lineColor = {56, 56, 56}, fillColor = {128, 202, 255}, fillPattern = FillPattern.Solid, points = {{99.752, 100}, {99.752, 59.956}, {99.752, -50}, {100, -100}, {49.752, -100}, {-19.752, -100.044}, {-100.248, -100}, {-100.248, -50}, {-90.248, 29.956}, {-90.248, 79.956}, {-40.248, 79.956}, {-20.138, 79.813}, {-0.248, 79.956}, {19.752, 99.956}, {39.752, 99.956}, {59.752, 99.956}}, smooth = Smooth.Bezier), Polygon(visible = true, origin = {0, -13.079}, lineColor = {192, 192, 192}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.HorizontalCylinder, points = {{100, -86.921}, {50, -86.921}, {-50, -86.921}, {-100, -86.921}, {-100, -36.921}, {-100, 53.079}, {-100, 103.079}, {-50, 103.079}, {0, 103.079}, {20, 83.079}, {50, 83.079}, {100, 83.079}, {100, 33.079}, {100, -36.921}}, smooth = Smooth.Bezier), Rectangle(visible = true, origin = {0, -5}, lineColor = {198, 198, 198}, fillColor = {238, 238, 238}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-100, -25}, {100, 25}}), Polygon(visible = true, origin = {-0, -10.704}, lineColor = {113, 113, 113}, fillColor = {255, 255, 255}, points = {{100, -89.296}, {50, -89.296}, {-50, -89.296}, {-100, -89.296}, {-100, -39.296}, {-100, 50.704}, {-100, 100.704}, {-50, 100.704}, {0, 100.704}, {20, 80.704}, {50, 80.704}, {100, 80.704}, {100, 30.704}, {100, -39.296}}, smooth = Smooth.Bezier)}));
  end Analysis;

  package Components "Package containing components to model a basic synthesizer"
    model C
      extends Modelica.Electrical.Analog.Interfaces.OnePort(v(start = 0));
      parameter Modelica.SIunits.Capacitance C(start = 1) = 1 "Capacitance" annotation(Evaluate = true);
    equation
      i = C * der(v);
      annotation(Documentation(info = "<html><div>
<p>Simple linear capacitor model.</p>
</div></html>", revisions = "<html>
<ul>
<li><i> 1998   </i>
       by Christoph Clauss<br> initially implemented<br>
       </li>
</ul>
</html>"), Icon(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}, initialScale = 0.1, grid = {10, 10}), graphics = {Line(visible = true, points = {{-10, 30}, {-10, -30}}, color = {64, 64, 64}), Line(visible = true, points = {{10, 30}, {10, -30}}, color = {64, 64, 64}), Line(visible = true, points = {{-100, 0}, {-10, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{10, 0}, {100, 0}}, color = {64, 64, 64}), Text(visible = true, textColor = {64, 64, 64}, extent = {{-136, -70}, {136, -40}}, textString = "C=%C"), Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 50}, {150, 90}}, textString = "%name")}), Diagram(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}), graphics = {Line(points = {{-20, 40}, {-20, -40}}, thickness = 0.5, color = {0, 0, 255}), Line(points = {{20, 40}, {20, -40}}, thickness = 0.5, color = {0, 0, 255}), Line(points = {{-96, 0}, {-20, 0}}, color = {0, 0, 255}), Line(points = {{20, 0}, {96, 0}}, color = {0, 0, 255})}));
    end C;

    model R
      parameter Modelica.SIunits.Resistance R(start = 1) = 1 annotation(Evaluate = false);
      extends Modelica.Electrical.Analog.Interfaces.OnePort;
    equation
      v = R * i;
      annotation(Documentation(info = "<html><p>Simple linear resistor&nbsp;model.</p></html>", revisions = "<html>
<ul>
<li><i> August 07, 2009   </i>
       by Anton Haumer<br> temperature dependency of resistance added<br>
       </li>
<li><i> March 11, 2009   </i>
       by Christoph Clauss<br> conditional heat port added<br>
       </li>
<li><i> 1998   </i>
       by Christoph Clauss<br> initially implemented<br>
       </li>
</ul>
</html>"), Icon(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {64, 64, 64}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, extent = {{-70, -30}, {70, 30}}), Line(visible = true, points = {{-100, 0}, {-70, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{70, 0}, {100, 0}}, color = {64, 64, 64}), Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 50}, {150, 90}}, textString = "%name"), Text(visible = true, textColor = {64, 64, 64}, extent = {{-143, -70}, {143, -40}}, textString = "R=%R")}), Diagram(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}), graphics = {Rectangle(extent = {{-70, 30}, {70, -30}}, lineColor = {0, 0, 255}), Line(points = {{-96, 0}, {-70, 0}}, color = {0, 0, 255}), Line(points = {{70, 0}, {96, 0}}, color = {0, 0, 255})}));
    end R;

    model P
      Modelica.Electrical.Analog.Interfaces.PositivePin p "Positive pin (potential p.v > n.v for positive voltage drop v)" annotation(Placement(transformation(extent = {{-110, -10}, {-90, 10}}, origin = {0, 50}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{-110, -10}, {-90, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Interfaces.NegativePin n "Negative pin" annotation(Placement(transformation(extent = {{110, -10}, {90, 10}}, origin = {0, 50}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{110, -10}, {90, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Interfaces.NegativePin m "Negative pin" annotation(Placement(transformation(extent = {{110, -10}, {90, 10}}, origin = {-100, -32.5}, rotation = 0), visible = true, iconTransformation(origin = {-100, -100}, extent = {{110, -10}, {90, 10}}, rotation = 0)));
      PR pR1(R = R) annotation(Placement(visible = true, transformation(origin = {-50, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      PR pR2(R = R) annotation(Placement(visible = true, transformation(origin = {50, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Modelica.SIunits.Resistance R(start = 1) = 1 annotation(Evaluate = true);
      Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-120, -50}, extent = {{-20, -20}, {20, 20}}, rotation = -360)));
    equation
      pR1.u = u;
      pR2.u = 1.0 - u;
      connect(pR1.p, p) annotation(Line(visible = true, origin = {-80, 46.833}, points = {{20, 3.167}, {-20, 3.167}}, color = {10, 90, 224}));
      connect(pR1.n, pR2.p) annotation(Line(visible = true, points = {{-40, 0}, {40, 0}}, color = {10, 90, 224}, origin = {0, 50}));
      connect(m, pR2.p) annotation(Line(visible = true, origin = {13.333, 21.667}, points = {{-13.333, -54.167}, {-13.333, 28.333}, {26.667, 28.333}}, color = {10, 90, 224}));
      connect(pR2.n, n) annotation(Line(visible = true, origin = {80, 50}, points = {{-20, 0}, {20, 0}}, color = {10, 90, 224}));
      annotation(Documentation(info = "<html><p>Three terminal potentiometer.</p></html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {64, 64, 64}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, extent = {{-70, -30}, {70, 30}}), Line(visible = true, points = {{-100, 0}, {-70, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{70, 0}, {100, 0}}, color = {64, 64, 64}), Text(visible = true, origin = {0, 10}, textColor = {64, 64, 64}, extent = {{-150, 50}, {150, 90}}, textString = "%name"), Text(visible = true, origin = {0, 100}, textColor = {64, 64, 64}, extent = {{-143, -70}, {143, -40}}, textString = "R=%R"), Line(visible = true, origin = {31.878, -64.337}, points = {{-31.878, -25.663}, {-31.878, 34.337}}, color = {64, 64, 64})}), Diagram(coordinateSystem(extent = {{-115, -45}, {115, 80}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
    end P;

    model PR
      parameter Modelica.SIunits.Resistance R(start = 1) = 1 annotation(Evaluate = true);
      extends Modelica.Electrical.Analog.Interfaces.OnePort;
      Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-20, -80}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {0, 120}, extent = {{-20, -20}, {20, 20}}, rotation = -90)));
    equation
      v = R * u * i;
      annotation(Documentation(info = "<html><div>
<p>Two&nbsp;terminal potentiometer.</p>
</div></html>", revisions = "<html>
<ul>
<li><i> August 07, 2009   </i>
       by Anton Haumer<br> temperature dependency of resistance added<br>
       </li>
<li><i> March 11, 2009   </i>
       by Christoph Clauss<br> conditional heat port added<br>
       </li>
<li><i> 1998   </i>
       by Christoph Clauss<br> initially implemented<br>
       </li>
</ul>
</html>"), Icon(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {64, 64, 64}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, extent = {{-70, -30}, {70, 30}}), Line(visible = true, points = {{-100, 0}, {-70, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{70, 0}, {100, 0}}, color = {64, 64, 64}), Text(visible = true, origin = {0, -16.565}, textColor = {64, 64, 64}, extent = {{-150, 50}, {150, 90}}, textString = "%name"), Text(visible = true, textColor = {64, 64, 64}, extent = {{-143, -70}, {143, -40}}, textString = "R=%R"), Line(visible = true, origin = {0, 65}, points = {{0, 35}, {0, -35}})}), Diagram(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}), graphics = {Rectangle(extent = {{-70, 30}, {70, -30}}, lineColor = {0, 0, 255}), Line(points = {{-96, 0}, {-70, 0}}, color = {0, 0, 255}), Line(points = {{70, 0}, {96, 0}}, color = {0, 0, 255})}));
    end PR;

    model Buffer
      Modelica.Electrical.Analog.Interfaces.PositivePin p "Positive pin of the input port" annotation(Placement(transformation(extent = {{-111, -61}, {-90, -40}}, origin = {60, 70.5}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{-111, -61}, {-90, -40}}, rotation = 0)));
      Modelica.Electrical.Analog.Interfaces.PositivePin outp "Output pin" annotation(Placement(transformation(extent = {{110, -10}, {90, 10}}, origin = {-60, 20}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{110, -10}, {90, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vin annotation(Placement(visible = true, transformation(origin = {-20, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 450)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-0, -32.75}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vout annotation(Placement(visible = true, transformation(origin = {20, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
    equation
      connect(p, vin.p) annotation(Line(visible = true, origin = {-26.833, 16.667}, points = {{-13.667, 3.333}, {6.833, 3.333}, {6.833, -6.667}}, color = {10, 90, 224}));
      connect(ground1.p, vin.n) annotation(Line(visible = true, origin = {-10, -17.063}, points = {{10, -5.688}, {10, -0.688}, {-10, -0.688}, {-10, 7.063}}, color = {10, 90, 224}));
      connect(vin.v, vout.v) annotation(Line(visible = true, origin = {1.5, 0}, points = {{-11.5, 0}, {11.5, -0}}, color = {1, 37, 163}));
      connect(vout.p, outp) annotation(Line(visible = true, origin = {26.667, 16.667}, points = {{-6.667, -6.667}, {-6.667, 3.333}, {13.333, 3.333}}, color = {10, 90, 224}));
      connect(vout.n, ground1.p) annotation(Line(visible = true, origin = {10.863, -14.428}, points = {{9.137, 4.428}, {9.137, -3.322}, {-10.863, -3.322}, {-10.863, -8.322}}, color = {10, 90, 224}));
      annotation(Documentation(info = "<html><p>Analog signal buffer.</p></html>"), Diagram(coordinateSystem(extent = {{-55, -40}, {55, 40}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, origin = {-0, -10}, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Polygon(visible = true, lineColor = {64, 64, 64}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{60, 0}, {-60, 70}, {-60, -70}, {60, 0}}), Line(visible = true, points = {{-100, 50}, {-60, 50}}, color = {64, 64, 64}), Line(visible = true, points = {{-100, -50}, {-60, -50}}, color = {64, 64, 64}), Line(visible = true, points = {{60, 0}, {100, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{-48, 32}, {-28, 32}}, color = {64, 64, 64}), Line(visible = true, points = {{-39, -20}, {-39, -41}}, color = {64, 64, 64}), Line(visible = true, points = {{-50, -31}, {-28, -31}}, color = {64, 64, 64}), Line(visible = true, origin = {-10, 57.5}, points = {{-90, -7.5}, {-90, 32.5}, {90, 32.5}, {90, -57.5}})}));
    end Buffer;

    model OpAmp
      Modelica.Electrical.Analog.Interfaces.PositivePin p "Positive pin of the input port" annotation(Placement(transformation(extent = {{-111, -61}, {-90, -40}}, origin = {60, 70.5}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{-111, -61}, {-90, -40}}, rotation = 0)));
      Modelica.Electrical.Analog.Interfaces.PositivePin outp "Output pin" annotation(Placement(transformation(extent = {{110, -10}, {90, 10}}, origin = {-50, 20}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{110, -10}, {90, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vin annotation(Placement(visible = true, transformation(origin = {-20, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 450)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {35, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vout annotation(Placement(visible = true, transformation(origin = {35, -0}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Modelica.Electrical.Analog.Interfaces.NegativePin pin_n annotation(Placement(visible = true, transformation(origin = {-40, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain1(k = 100000) annotation(Placement(visible = true, transformation(origin = {10, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(p, vin.p) annotation(Line(visible = true, origin = {-26.833, 16.667}, points = {{-13.667, 3.333}, {6.833, 3.333}, {6.833, -6.667}}, color = {10, 90, 224}));
      connect(vout.p, outp) annotation(Line(visible = true, origin = {40, 16.667}, points = {{-5, -6.667}, {-5, 3.333}, {10, 3.333}}, color = {10, 90, 224}));
      connect(vout.n, ground1.p) annotation(Line(visible = true, origin = {10.863, -14.428}, points = {{24.137, 4.428}, {24.137, -3.322}, {24.137, -3.322}, {24.137, -5.572}}, color = {10, 90, 224}));
      connect(vin.n, pin_n) annotation(Line(visible = true, origin = {-26.667, -16.667}, points = {{6.667, 6.667}, {6.667, -3.333}, {-13.333, -3.333}}, color = {10, 90, 224}));
      connect(vin.v, gain1.u) annotation(Line(visible = true, origin = {-6, -0}, points = {{-4, -0}, {4, 0}}, color = {1, 37, 163}));
      connect(gain1.y, vout.v) annotation(Line(visible = true, origin = {24.5, 0}, points = {{-3.5, 0}, {3.5, -0}}, color = {1, 37, 163}));
      annotation(Documentation(info = "<html><p>Analog signal buffer.</p></html>"), Diagram(coordinateSystem(extent = {{-55, -40}, {55, 40}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, origin = {0, -10}, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Polygon(visible = true, lineColor = {64, 64, 64}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{60, 0}, {-60, 70}, {-60, -70}, {60, 0}}), Line(visible = true, points = {{-100, 50}, {-60, 50}}, color = {64, 64, 64}), Line(visible = true, points = {{-100, -50}, {-60, -50}}, color = {64, 64, 64}), Line(visible = true, points = {{60, 0}, {100, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{-48, 32}, {-28, 32}}, color = {64, 64, 64}), Line(visible = true, points = {{-39, -20}, {-39, -41}}, color = {64, 64, 64}), Line(visible = true, points = {{-50, -31}, {-28, -31}}, color = {64, 64, 64})}));
    end OpAmp;

    model OpAmpLim
      Modelica.Electrical.Analog.Interfaces.PositivePin p "Positive pin of the input port" annotation(Placement(transformation(extent = {{-111, -61}, {-90, -40}}, origin = {60, 70.5}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{-111, -61}, {-90, -40}}, rotation = 0)));
      Modelica.Electrical.Analog.Interfaces.PositivePin outp "Output pin" annotation(Placement(transformation(extent = {{110, -10}, {90, 10}}, origin = {-7.5, 20}, rotation = 0), visible = true, iconTransformation(origin = {0, 0}, extent = {{110, -10}, {90, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sensors.VoltageSensor vin annotation(Placement(visible = true, transformation(origin = {-20, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 450)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {77.5, -30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.SignalVoltage vout annotation(Placement(visible = true, transformation(origin = {77.5, 0}, extent = {{10, -10}, {-10, 10}}, rotation = 90)));
      Modelica.Electrical.Analog.Interfaces.NegativePin pin_n annotation(Placement(visible = true, transformation(origin = {-40, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain1(k = 100000) annotation(Placement(visible = true, transformation(origin = {10, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Nonlinear.Limiter limiter1(uMax = MaxV) annotation(Placement(visible = true, transformation(origin = {45, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Real MaxV = 15;
    equation
      connect(p, vin.p) annotation(Line(visible = true, origin = {-26.833, 16.667}, points = {{-13.667, 3.333}, {6.833, 3.333}, {6.833, -6.667}}, color = {10, 90, 224}));
      connect(vout.p, outp) annotation(Line(visible = true, origin = {82.5, 16.667}, points = {{-5, -6.667}, {-5, 3.333}, {10, 3.333}}, color = {10, 90, 224}));
      connect(vout.n, ground1.p) annotation(Line(visible = true, origin = {53.363, -14.428}, points = {{24.137, 4.428}, {24.137, -3.322}, {24.137, -3.322}, {24.137, -5.572}}, color = {10, 90, 224}));
      connect(vin.n, pin_n) annotation(Line(visible = true, origin = {-26.667, -16.667}, points = {{6.667, 6.667}, {6.667, -3.333}, {-13.333, -3.333}}, color = {10, 90, 224}));
      connect(vin.v, gain1.u) annotation(Line(visible = true, origin = {-6, -0}, points = {{-4, -0}, {4, 0}}, color = {1, 37, 163}));
      connect(limiter1.u, gain1.y) annotation(Line(visible = true, origin = {27, 0}, points = {{6, 0}, {-6, -0}}, color = {1, 37, 163}));
      connect(limiter1.y, vout.v) annotation(Line(visible = true, origin = {63.25, 0}, points = {{-7.25, 0}, {7.25, -0}}, color = {1, 37, 163}));
      annotation(Documentation(info = "<html><p>Analog signal buffer.</p></html>"), Diagram(coordinateSystem(extent = {{-55, -40}, {95, 40}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, origin = {0, -10}, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name"), Polygon(visible = true, lineColor = {64, 64, 64}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{60, 0}, {-60, 70}, {-60, -70}, {60, 0}}), Line(visible = true, points = {{-100, 50}, {-60, 50}}, color = {64, 64, 64}), Line(visible = true, points = {{-100, -50}, {-60, -50}}, color = {64, 64, 64}), Line(visible = true, points = {{60, 0}, {100, 0}}, color = {64, 64, 64}), Line(visible = true, points = {{-48, 32}, {-28, 32}}, color = {64, 64, 64}), Line(visible = true, points = {{-39, -20}, {-39, -41}}, color = {64, 64, 64}), Line(visible = true, points = {{-50, -31}, {-28, -31}}, color = {64, 64, 64})}));
    end OpAmpLim;

    model VCC
      parameter Real V = +15;
      Modelica.Electrical.Analog.Interfaces.Pin pin annotation(Placement(visible = true, transformation(origin = {-15, -2.527}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-0, -100}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Electrical.Analog.Sources.ConstantVoltage constantVoltage1(V = V) annotation(Placement(visible = true, transformation(origin = {-15, -40}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
      Components.Ground ground1 annotation(Placement(visible = true, transformation(origin = {-15, -70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(constantVoltage1.n, ground1.p) annotation(Line(visible = true, origin = {-15, -55}, points = {{-0, 5}, {0, -5}}, color = {10, 90, 224}));
      connect(constantVoltage1.p, pin) annotation(Line(visible = true, origin = {-15, -16.263}, points = {{-0, -13.737}, {0, 13.737}}, color = {10, 90, 224}));
      annotation(Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Text(visible = true, origin = {-0, 20}, extent = {{-53.311, -16.673}, {53.311, 16.673}}, textString = "%V"), Line(visible = true, origin = {0, -51.006}, points = {{0, -51.006}, {0, 51.006}}), Line(visible = true, points = {{-50, 0}, {50, 0}})}), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})));
    end VCC;

    model Ground "Ground node"
      Modelica.Electrical.Analog.Interfaces.Pin p annotation(Placement(transformation(origin = {0, 100}, extent = {{10, -10}, {-10, 10}}, rotation = 270)));
    equation
      p.v = 0;
      annotation(Documentation(info = "<html>
<p>Ground of an electrical circuit. The potential at the ground node is zero. Every electrical circuit has to contain at least one ground object.</p>
</html>", revisions = "<html>
<ul>
<li><em> 1998   </em>
       by Christoph Clauss<br> initially implemented<br>
       </li>
</ul>
</html>"), Icon(coordinateSystem(preserveAspectRatio = true, extent = {{-100, -100}, {100, 100}}, initialScale = 0.1, grid = {10, 10}), graphics = {Line(visible = true, points = {{-60, 50}, {60, 50}}, color = {64, 64, 64}), Line(visible = true, points = {{-40, 30}, {40, 30}}, color = {64, 64, 64}), Line(visible = true, points = {{-20, 10}, {20, 10}}, color = {64, 64, 64}), Line(visible = true, points = {{0, 100}, {0, 50}}, color = {64, 64, 64})}));
    end Ground;

    model RandomSource
      Modelica.Blocks.Interfaces.BooleanInput u annotation(Placement(visible = true, transformation(origin = {-75, 1.763}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {159.335, 10.95}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Integer localSeed = 0;
      parameter Integer globalSeed = 0;
      Integer state[Modelica.Math.Random.Generators.Xorshift64star.nState];
      Real r;
      Modelica.Blocks.Sources.RealExpression realExpression1(y = Min + Max * r) annotation(Placement(visible = true, transformation(origin = {27.236, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut = 1000) annotation(Placement(visible = true, transformation(origin = {80, 10}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Real Min = 0;
      parameter Real Max = 1;
    initial equation
      state = Modelica.Math.Random.Generators.Xorshift64star.initialState(localSeed, globalSeed);
    equation
      when u then
        (r, state) = Modelica.Math.Random.Generators.Xorshift64star.random(pre(state));
      end when;
      connect(filter1.y, y) annotation(Line(visible = true, origin = {136.557, 10.317}, points = {{-45.557, -0.317}, {22.778, -0.317}, {22.778, 0.633}}, color = {1, 37, 163}));
      connect(realExpression1.y, filter1.u) annotation(Line(visible = true, origin = {53.118, 10}, points = {{-14.882, 0}, {14.882, -0}}, color = {1, 37, 163}));
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name")}));
    end RandomSource;

    model PulseGenerator
      Modelica.Blocks.Interfaces.BooleanInput u annotation(Placement(visible = true, transformation(origin = {-140, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-100, -0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.BooleanOutput y annotation(Placement(visible = true, transformation(origin = {150, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      parameter Integer Length = 32;
      parameter Integer Pulses = 23;
      Modelica.Blocks.Sources.SawTooth sawTooth1(period = 1 / 8 * Length) annotation(Placement(visible = true, transformation(origin = {-117.609, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.IntegerChange integerChange1 annotation(Placement(visible = true, transformation(origin = {70, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Discrete.TriggeredSampler triggeredSampler1 annotation(Placement(visible = true, transformation(origin = {-52.318, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.RealToInteger realToInteger1 annotation(Placement(visible = true, transformation(origin = {-15, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Math.Gain gain1(k = Pulses) annotation(Placement(visible = true, transformation(origin = {-85, 30}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(integerChange1.y, y) annotation(Line(visible = true, origin = {115.5, 30}, points = {{-34.5, 0}, {34.5, -0}}, color = {255, 0, 255}));
      connect(u, triggeredSampler1.trigger) annotation(Line(visible = true, origin = {-74.009, 9}, points = {{-65.991, -9}, {22.15, -9}, {22.15, 9}, {21.691, 9}}, color = {190, 52, 178}));
      connect(triggeredSampler1.y, realToInteger1.u) annotation(Line(visible = true, origin = {-36.515, 30}, points = {{-4.803, 0}, {9.515, 0}}, color = {1, 37, 163}));
      connect(realToInteger1.y, integerChange1.u) annotation(Line(visible = true, origin = {24.303, 30}, points = {{-28.303, 0}, {33.697, 0}}, color = {255, 127, 0}));
      connect(gain1.u, sawTooth1.y) annotation(Line(visible = true, origin = {-101.804, 30}, points = {{4.804, 0}, {-4.804, 0}}, color = {1, 37, 163}));
      connect(gain1.y, triggeredSampler1.u) annotation(Line(visible = true, origin = {-69.159, 30}, points = {{-4.841, 0}, {4.841, 0}}, color = {1, 37, 163}));
      annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name")}));
    end PulseGenerator;
    annotation(Documentation(info = "<html><p>Minimal set of components to model a basic synthesizer.</p></html>"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Polygon(visible = true, origin = {0.248, 0.044}, lineColor = {56, 56, 56}, fillColor = {128, 202, 255}, fillPattern = FillPattern.Solid, points = {{99.752, 100}, {99.752, 59.956}, {99.752, -50}, {100, -100}, {49.752, -100}, {-19.752, -100.044}, {-100.248, -100}, {-100.248, -50}, {-90.248, 29.956}, {-90.248, 79.956}, {-40.248, 79.956}, {-20.138, 79.813}, {-0.248, 79.956}, {19.752, 99.956}, {39.752, 99.956}, {59.752, 99.956}}, smooth = Smooth.Bezier), Polygon(visible = true, origin = {0, -13.079}, lineColor = {192, 192, 192}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.HorizontalCylinder, points = {{100, -86.921}, {50, -86.921}, {-50, -86.921}, {-100, -86.921}, {-100, -36.921}, {-100, 53.079}, {-100, 103.079}, {-50, 103.079}, {0, 103.079}, {20, 83.079}, {50, 83.079}, {100, 83.079}, {100, 33.079}, {100, -36.921}}, smooth = Smooth.Bezier), Rectangle(visible = true, origin = {0, -5}, lineColor = {198, 198, 198}, fillColor = {238, 238, 238}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-100, -25}, {100, 25}}), Polygon(visible = true, origin = {-0, -10.704}, lineColor = {113, 113, 113}, fillColor = {255, 255, 255}, points = {{100, -89.296}, {50, -89.296}, {-50, -89.296}, {-100, -89.296}, {-100, -39.296}, {-100, 50.704}, {-100, 100.704}, {-50, 100.704}, {0, 100.704}, {20, 80.704}, {50, 80.704}, {100, 80.704}, {100, 30.704}, {100, -39.296}}, smooth = Smooth.Bezier)}));
  end Components;

  package Tests
    model Section1_Test
      Simplified.Section1 section1_1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.BooleanPulse Trigger1(period = 100e-3, width = 10) annotation(Placement(visible = true, transformation(origin = {-30, -20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Ramp ramp1(height = 8, duration = 4) annotation(Placement(visible = true, transformation(origin = {-30, 20}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(Trigger1.y, section1_1.Trigger) annotation(Line(visible = true, origin = {-14.75, -12.5}, points = {{-4.25, -7.5}, {-0.25, -7.5}, {-0.25, 7.5}, {4.75, 7.5}}, color = {255, 0, 255}));
      connect(ramp1.y, section1_1.Accent) annotation(Line(visible = true, origin = {-15.5, 12.5}, points = {{-3.5, 7.5}, {-1, 7.5}, {-1, -7.5}, {5.5, -7.5}}, color = {1, 37, 163}));
      annotation(experiment(StopTime = 4, __Wolfram_NumberOfIntervals = 2000, __Wolfram_Algorithm = "cvodes"), Documentation(figures = {Figure(title = "Section 1", identifier = "3c5ef", preferred = true, plots = {Plot(curves = {Curve(y = section1_1.Output, legend = "Output"), Curve(y = section1_1.Accent, legend = "Accent")}), Plot(curves = {Curve(y = Trigger1.y, legend = "Trigger")})}, caption = "Output using the simplified model")}), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section1_Test;

    model Section2_Test
      Simplified.Section2 section2_1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.Pulse pulse1(amplitude = 5, period = 10e-3, width = 3) annotation(Placement(visible = true, transformation(origin = {-60, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Continuous.Filter filter1(f_cut(displayUnit = "kHz") = 100000) annotation(Placement(visible = true, transformation(origin = {-30, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(filter1.u, pulse1.y) annotation(Line(visible = true, origin = {-45.5, 0}, points = {{3.5, 0}, {-3.5, 0}}, color = {1, 37, 163}));
      connect(filter1.y, section2_1.u) annotation(Line(visible = true, origin = {-14.5, 0}, points = {{-4.5, 0}, {4.5, 0}}, color = {1, 37, 163}));
      annotation(Documentation(figures = {Figure(title = "Section 2", identifier = "e4660", preferred = true, plots = {Plot(curves = {Curve(y = section2_1.u, legend = "Trigger"), Curve(y = section2_1.y, legend = "Output")}, x = Axis(min = 0.1298, max = 0.131, unit = "s"), y = Axis(min = -0.1723962456180024, max = 5.091654415922197))}, caption = "Output of the circuit using a limiter instead of a diode")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Ellipse(visible = true, lineColor = {0, 114, 195}, fillColor = {0, 114, 195}, fillPattern = FillPattern.Solid, extent = {{-100, -100}, {100, 100}}), Polygon(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, fillPattern = FillPattern.Solid, points = {{-36, 60}, {64, 0}, {-36, -60}, {-36, 60}})}));
    end Section2_Test;

    model Section57_Test
      Simplified.Section5 section5_1 annotation(Placement(visible = true, transformation(origin = {-5, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Simplified.Section7 section7_1 annotation(Placement(visible = true, transformation(origin = {30, -0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      Modelica.Blocks.Sources.BooleanPulse Trigger1(period = 0.5, width = 1e-3 / 0.5 * 100) annotation(Placement(visible = true, transformation(origin = {-37.244, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      connect(Trigger1.y, section5_1.u) annotation(Line(visible = true, origin = {-20.622, -0}, points = {{-5.622, 0}, {5.622, -0}}, color = {255, 0, 255}));
      connect(section5_1.y, section7_1.s5) annotation(Line(visible = true, origin = {11.25, 2.5}, points = {{-6.25, 2.5}, {-1.25, 2.5}, {-1.25, -2.5}, {8.75, -2.5}}, color = {255, 0, 255}));
      annotation(Documentation(figures = {Figure(title = "Section 5 & 7", identifier = "d0dee", preferred = true, plots = {Plot(curves = {Curve(y = Trigger1.y, legend = "Trigger"), Curve(y = section5_1.y, legend = "Section 5")}, x = Axis(min = 0.49, max = 0.59, unit = "s"), y = Axis(min = -0.05736040609137061, max = 1.051269035532995)), Plot(curves = {Curve(y = section7_1.y, legend = "Section 7")}, x = Axis(min = 0.49, max = 0.59, unit = "s"))}, caption = "Output of the simplified models")}), experiment(StopTime = 4, __Wolfram_NumberOfIntervals = -1, __Wolfram_Algorithm = "cvodes"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, lineColor = {0, 114, 195}, fillColor = {255, 255, 255}, extent = {{-100, -100}, {100, 100}}, radius = 25), Text(visible = true, textColor = {64, 64, 64}, extent = {{-150, 110}, {150, 150}}, textString = "%name")}));
    end Section57_Test;
    annotation(Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Polygon(visible = true, origin = {0.248, 0.044}, lineColor = {56, 56, 56}, fillColor = {128, 202, 255}, fillPattern = FillPattern.Solid, points = {{99.752, 100}, {99.752, 59.956}, {99.752, -50}, {100, -100}, {49.752, -100}, {-19.752, -100.044}, {-100.248, -100}, {-100.248, -50}, {-90.248, 29.956}, {-90.248, 79.956}, {-40.248, 79.956}, {-20.138, 79.813}, {-0.248, 79.956}, {19.752, 99.956}, {39.752, 99.956}, {59.752, 99.956}}, smooth = Smooth.Bezier), Polygon(visible = true, origin = {0, -13.079}, lineColor = {192, 192, 192}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.HorizontalCylinder, points = {{100, -86.921}, {50, -86.921}, {-50, -86.921}, {-100, -86.921}, {-100, -36.921}, {-100, 53.079}, {-100, 103.079}, {-50, 103.079}, {0, 103.079}, {20, 83.079}, {50, 83.079}, {100, 83.079}, {100, 33.079}, {100, -36.921}}, smooth = Smooth.Bezier), Rectangle(visible = true, origin = {0, -5}, lineColor = {198, 198, 198}, fillColor = {238, 238, 238}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-100, -25}, {100, 25}}), Polygon(visible = true, origin = {-0, -10.704}, lineColor = {113, 113, 113}, fillColor = {255, 255, 255}, points = {{100, -89.296}, {50, -89.296}, {-50, -89.296}, {-100, -89.296}, {-100, -39.296}, {-100, 50.704}, {-100, 100.704}, {-50, 100.704}, {0, 100.704}, {20, 80.704}, {50, 80.704}, {100, 80.704}, {100, 30.704}, {100, -39.296}}, smooth = Smooth.Bezier)}));
  end Tests;

  package WaveIO "Package containing components to read and write WAV files"
    extends Modelica.Icons.Package;

    model WriteMono
      parameter String filename = "output.wav";
      parameter Integer sampleRate = 44100;
      parameter Real gain = 1.0;
      Internal.WaveIO_object obj = Internal.WaveIO_object.constructor(filename, sampleRate, 1, false);
      Modelica.Blocks.Interfaces.RealInput u annotation(Placement(visible = true, transformation(origin = {-120, -0}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-120, 0}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
    equation
      when sample(0, 1.0 / sampleRate) then
        Internal.write_mono(obj, u * gain);
      end when;
      annotation(preferredView = "text", Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {0.272, 3.284}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-89.728, -54.844}, {89.728, 54.844}}, radius = 10), Polygon(visible = true, origin = {-14.022, -34.968}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-47.459, 11.39}, {74.474, 11.39}, {86.481, -16.592}, {-58.437, -16.592}}), Polygon(visible = true, origin = {-11.563, -35.047}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-46.8, 7.478}, {69.052, 7.478}, {79.536, -16.592}, {-56.061, -16.592}}), Ellipse(visible = true, origin = {-78.909, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {-80, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.876, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.851, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Rectangle(visible = true, origin = {-30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {-44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Ellipse(visible = true, origin = {0, -33.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {85, 123, 168}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, -44.31}, {79.952, -44.31}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, 8.697}, {79.952, 8.697}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Ellipse(visible = true, origin = {-50, 7.607}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Ellipse(visible = true, origin = {47.597, 7.544}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Rectangle(visible = true, origin = {-1.321, 7.574}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-48.679, -14.209}, {48.679, 14.209}}), Ellipse(visible = true, origin = {-42.194, 7.443}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {35.313, 7.331}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {-42.083, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Ellipse(visible = true, origin = {35.333, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Rectangle(visible = true, origin = {-1.669, 8.028}, fillColor = {179, 179, 179}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-19.872, -9.557}, {19.872, 9.557}}, radius = 3)}), Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10})));
    end WriteMono;

    model WriteStereo
      parameter String filename = "output.wav";
      parameter Integer sampleRate = 44100;
      Internal.WaveIO_object obj = Internal.WaveIO_object.constructor(filename, sampleRate, 2, false);
      Modelica.Blocks.Interfaces.RealInput left annotation(Placement(visible = true, transformation(origin = {-120, 40}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-120, 50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
      Modelica.Blocks.Interfaces.RealInput right annotation(Placement(visible = true, transformation(origin = {-120, -40}, extent = {{-20, -20}, {20, 20}}, rotation = 0), iconTransformation(origin = {-120, -50}, extent = {{-20, -20}, {20, 20}}, rotation = 0)));
    equation
      when sample(0, 1.0 / sampleRate) then
        Internal.write_stereo(obj, left, right);
      end when;
      annotation(preferredView = "text", Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {0.272, 3.284}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-89.728, -54.844}, {89.728, 54.844}}, radius = 10), Polygon(visible = true, origin = {-14.022, -34.968}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-47.459, 11.39}, {74.474, 11.39}, {86.481, -16.592}, {-58.437, -16.592}}), Polygon(visible = true, origin = {-11.563, -35.047}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-46.8, 7.478}, {69.052, 7.478}, {79.536, -16.592}, {-56.061, -16.592}}), Ellipse(visible = true, origin = {-78.909, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {-80, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.876, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.851, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Rectangle(visible = true, origin = {-30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {-44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Ellipse(visible = true, origin = {0, -33.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {85, 123, 168}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, -44.31}, {79.952, -44.31}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, 8.697}, {79.952, 8.697}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Ellipse(visible = true, origin = {-50, 7.607}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Ellipse(visible = true, origin = {47.597, 7.544}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Rectangle(visible = true, origin = {-1.321, 7.574}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-48.679, -14.209}, {48.679, 14.209}}), Ellipse(visible = true, origin = {-42.194, 7.443}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {35.313, 7.331}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {-42.083, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Ellipse(visible = true, origin = {35.333, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Rectangle(visible = true, origin = {-1.669, 8.028}, fillColor = {179, 179, 179}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-19.872, -9.557}, {19.872, 9.557}}, radius = 3)}));
    end WriteStereo;

    model ReadStereo
      parameter String filename = "output.wav";
      parameter Integer sampleRate = 44100;
      Internal.WaveIO_object obj = Internal.WaveIO_object.constructor(filename, sampleRate, 2, true);
      discrete Modelica.Blocks.Interfaces.RealOutput left annotation(Placement(visible = true, transformation(origin = {110, 40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {110, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
      discrete Modelica.Blocks.Interfaces.RealOutput right annotation(Placement(visible = true, transformation(origin = {110, -40}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {110, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      when sample(0, 1.0 / sampleRate) then
        (left, right) = Internal.read_stereo(obj);
      end when;
      annotation(preferredView = "text", Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {0.272, 3.284}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-89.728, -54.844}, {89.728, 54.844}}, radius = 10), Polygon(visible = true, origin = {-14.022, -34.968}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-47.459, 11.39}, {74.474, 11.39}, {86.481, -16.592}, {-58.437, -16.592}}), Polygon(visible = true, origin = {-11.563, -35.047}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-46.8, 7.478}, {69.052, 7.478}, {79.536, -16.592}, {-56.061, -16.592}}), Ellipse(visible = true, origin = {-78.909, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {-80, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.876, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.851, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Rectangle(visible = true, origin = {-30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {-44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Ellipse(visible = true, origin = {0, -33.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {175, 92, 13}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, -44.31}, {79.952, -44.31}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, 8.697}, {79.952, 8.697}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Ellipse(visible = true, origin = {-50, 7.607}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Ellipse(visible = true, origin = {47.597, 7.544}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Rectangle(visible = true, origin = {-1.321, 7.574}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-48.679, -14.209}, {48.679, 14.209}}), Ellipse(visible = true, origin = {-42.194, 7.443}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {35.313, 7.331}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {-42.083, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Ellipse(visible = true, origin = {35.333, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Rectangle(visible = true, origin = {-1.669, 8.028}, fillColor = {179, 179, 179}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-19.872, -9.557}, {19.872, 9.557}}, radius = 3)}));
    end ReadStereo;

    model ReadMono
      parameter String filename = "output.wav";
      parameter Integer sampleRate = 44100;
      Internal.WaveIO_object obj = Internal.WaveIO_object.constructor(filename, sampleRate, 1, true);
      discrete Modelica.Blocks.Interfaces.RealOutput y annotation(Placement(visible = true, transformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {110, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    equation
      when sample(0, 1.0 / sampleRate) then
        y = Internal.read_stereo(obj);
      end when;
      annotation(preferredView = "text", Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {1.803, 4.22}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-91.259, -55.78}, {91.259, 55.78}}, radius = 10), Polygon(visible = true, origin = {-14.022, -34.968}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-47.459, 11.39}, {74.474, 11.39}, {86.481, -16.592}, {-58.437, -16.592}}), Polygon(visible = true, origin = {-11.563, -35.047}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-46.8, 7.478}, {69.052, 7.478}, {79.536, -16.592}, {-56.061, -16.592}}), Ellipse(visible = true, origin = {-78.909, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {-80, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.876, 50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.851, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Rectangle(visible = true, origin = {-30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {-44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {30, -40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {44.494, -45.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Ellipse(visible = true, origin = {0, -33.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {175, 92, 13}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, -44.31}, {79.952, -44.31}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Polygon(visible = true, origin = {0.048, 24.31}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, 8.697}, {79.952, 8.697}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Ellipse(visible = true, origin = {-50, 7.607}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Ellipse(visible = true, origin = {47.597, 7.544}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Rectangle(visible = true, origin = {-1.321, 7.574}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-48.679, -14.209}, {48.679, 14.209}}), Ellipse(visible = true, origin = {-42.194, 7.443}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {35.313, 7.331}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {-42.083, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Ellipse(visible = true, origin = {35.333, 7.498}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Rectangle(visible = true, origin = {-1.669, 8.028}, fillColor = {179, 179, 179}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-19.872, -9.557}, {19.872, 9.557}}, radius = 3)}));
    end ReadMono;

    package Internal
      extends Modelica.Icons.InternalPackage;

      class WaveIO_object
        extends ExternalObject;

        function constructor
          output WaveIO_object obj;
          input String filename;
          input Integer sampleRate;
          input Integer channels;
          input Boolean in_out;
        
          external "C" obj = WaveIO__constructor(filename, sampleRate, channels, in_out) annotation(Include = "#include \"WaveIO.h\"", Library = "WaveIO", IncludeDirectory = "modelica://DrumModeling/Resources/Include", LibraryDirectory = "modelica://DrumModeling/Resources/Library");
        end constructor;

        function destructor
          input WaveIO_object obj;
        
          external "C" WaveIO__destructor(obj) annotation(Include = "#include \"WaveIO.h\"", Library = "WaveIO", IncludeDirectory = "modelica://DrumModeling/Resources/Include", LibraryDirectory = "modelica://DrumModeling/Resources/Library");
        end destructor;
      end WaveIO_object;

      function write_stereo
        input WaveIO_object obj;
        input Real in0;
        input Real in1;
        extends Modelica.Icons.Function;
      
        external "C" WaveIO__write_stereo(obj, in0, in1) annotation(Include = "#include \"WaveIO.h\"", Library = "WaveIO", IncludeDirectory = "modelica://DrumModeling/Resources/Include", LibraryDirectory = "modelica://DrumModeling/Resources/Library");
      end write_stereo;

      function write_mono
        input WaveIO_object obj;
        input Real in0;
        extends Modelica.Icons.Function;
      
        external "C" WaveIO__write_mono(obj, in0) annotation(Include = "#include \"WaveIO.h\"", Library = "WaveIO", IncludeDirectory = "modelica://DrumModeling/Resources/Include", LibraryDirectory = "modelica://DrumModeling/Resources/Library");
      end write_mono;

      function read_stereo
        input WaveIO_object obj;
        output Real out0;
        output Real out1;
        extends Modelica.Icons.Function;
      
        external "C" WaveIO__read_stereo(obj, out0, out1) annotation(Include = "#include \"WaveIO.h\"", Library = "WaveIO", IncludeDirectory = "modelica://DrumModeling/Resources/Include", LibraryDirectory = "modelica://DrumModeling/Resources/Library");
      end read_stereo;

      function read_mono
        input WaveIO_object obj;
        output Real out0;
        output Real out1;
        extends Modelica.Icons.Function;
      
        external "C" WaveIO__read_stereo(obj, out0) annotation(Include = "#include \"WaveIO.h\"", Library = "WaveIO", IncludeDirectory = "modelica://DrumModeling/Resources/Include", LibraryDirectory = "modelica://DrumModeling/Resources/Library");
      end read_mono;
    end Internal;
    annotation(Documentation(info = "<html><p>WaveIO is a simple Modelica library to read and write WAV files from System Modeler simulations.</p>
<p>&nbsp;</p>
<p>Author: Leonardo Laguna Ruiz</p></html>"), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = false, initialScale = 0.1, grid = {10, 10}), graphics = {Rectangle(visible = true, origin = {0.272, -6.716}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-89.728, -54.844}, {89.728, 54.844}}, radius = 10), Polygon(visible = true, origin = {-14.022, -44.968}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-47.459, 11.39}, {74.474, 11.39}, {86.481, -16.592}, {-58.437, -16.592}}), Polygon(visible = true, origin = {-11.563, -45.047}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-46.8, 7.478}, {69.052, 7.478}, {79.536, -16.592}, {-56.061, -16.592}}), Ellipse(visible = true, origin = {-78.909, -53.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {-80, 40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.876, 40}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Ellipse(visible = true, origin = {81.851, -53.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Rectangle(visible = true, origin = {-30, -50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {-44.494, -55.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {30, -50}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Rectangle(visible = true, origin = {44.494, -55.947}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-4.494, -4.053}, {4.494, 4.053}}, radius = 2), Ellipse(visible = true, origin = {0, -43.915}, fillColor = {153, 153, 153}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-3.917, -3.915}, {3.917, 3.915}}), Polygon(visible = true, origin = {0.048, 14.31}, fillColor = {133, 121, 39}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, -44.31}, {79.952, -44.31}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Polygon(visible = true, origin = {0.048, 14.31}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, points = {{-80.048, 8.697}, {79.952, 8.697}, {79.952, 18.476}, {72.137, 25.69}, {-71.946, 25.69}, {-80.048, 18.763}}), Ellipse(visible = true, origin = {-50, -2.393}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Ellipse(visible = true, origin = {47.597, -2.456}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-14.381, -14.184}, {14.381, 14.184}}), Rectangle(visible = true, origin = {-1.321, -2.426}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-48.679, -14.209}, {48.679, 14.209}}), Ellipse(visible = true, origin = {-42.194, -2.557}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {35.313, -2.669}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-9.508, -9.169}, {9.508, 9.169}}), Ellipse(visible = true, origin = {-42.083, -2.502}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Ellipse(visible = true, origin = {35.333, -2.502}, fillColor = {76, 76, 76}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-7.917, -7.498}, {7.917, 7.498}}), Rectangle(visible = true, origin = {-1.669, -1.972}, fillColor = {179, 179, 179}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-19.872, -9.557}, {19.872, 9.557}}, radius = 3)}));
  end WaveIO;
  annotation(Documentation(info = "<html><div>
<p class=\"p1\"><span class=\"s1\">A small library to illustrate how simple electrical models can be used to analyze sound synthesizers.</span></p>
<p class=\"p1\">&nbsp;</p>
<p class=\"p1\"><span class=\"s1\">Author: Leonardo Laguna Ruiz</span></p>
</div></html>"), Diagram(coordinateSystem(extent = {{-150, -90}, {150, 90}}, preserveAspectRatio = true, initialScale = 0.1, grid = {5, 5})), Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10, 10}), graphics = {Polygon(visible = true, origin = {0.248, 0.044}, lineColor = {56, 56, 56}, fillColor = {128, 202, 255}, fillPattern = FillPattern.Solid, points = {{99.752, 100}, {99.752, 59.956}, {99.752, -50}, {100, -100}, {49.752, -100}, {-19.752, -100.044}, {-100.248, -100}, {-100.248, -50}, {-90.248, 29.956}, {-90.248, 79.956}, {-40.248, 79.956}, {-20.138, 79.813}, {-0.248, 79.956}, {19.752, 99.956}, {39.752, 99.956}, {59.752, 99.956}}, smooth = Smooth.Bezier), Polygon(visible = true, origin = {0, -13.079}, lineColor = {192, 192, 192}, fillColor = {255, 255, 255}, pattern = LinePattern.None, fillPattern = FillPattern.HorizontalCylinder, points = {{100, -86.921}, {50, -86.921}, {-50, -86.921}, {-100, -86.921}, {-100, -36.921}, {-100, 53.079}, {-100, 103.079}, {-50, 103.079}, {0, 103.079}, {20, 83.079}, {50, 83.079}, {100, 83.079}, {100, 33.079}, {100, -36.921}}, smooth = Smooth.Bezier), Rectangle(visible = true, origin = {0, -5}, lineColor = {198, 198, 198}, fillColor = {238, 238, 238}, pattern = LinePattern.None, fillPattern = FillPattern.Solid, extent = {{-100, -25}, {100, 25}}), Polygon(visible = true, origin = {-0, -10.704}, lineColor = {113, 113, 113}, fillColor = {255, 255, 255}, points = {{100, -89.296}, {50, -89.296}, {-50, -89.296}, {-100, -89.296}, {-100, -39.296}, {-100, 50.704}, {-100, 100.704}, {-50, 100.704}, {0, 100.704}, {20, 80.704}, {50, 80.704}, {100, 80.704}, {100, 30.704}, {100, -39.296}}, smooth = Smooth.Bezier)}));
end DrumModeling;
